;-------------------------------------------------------------------------
;  Return of the Very Tiny Language
;  file : rvtl.asm
;  version : 3.04  2010/02/28
;  Copyright (C) 2002-2010 Jun Mizutani <mizutani.jun@nifty.ne.jp>
;  RVTL may be copied under the terms of the GNU General Public License.
;
; build :
;   nasm -f elf rvtl.asm
;   ld -s -o rvtl rvtl.o
;
; build small rvtl :
;   nasm -f elf rvtl.asm -dSMALL_VTL
;   ld -s -o rvtls rvtl.o
;
;-------------------------------------------------------------------------

%include        "vtllib.inc"
%include        "mt19937.inc"

%define VTL_LABEL

%ifdef  SMALL_VTL
  %undef  FRAME_BUFFER
  %undef  DETAILED_MSG
  %define NO_FB
%else
  %define DETAILED_MSG
  %include      "syserror.inc"
%endif

%ifndef  NO_FB
  %define FRAME_BUFFER
  %include      "fblib.inc"
%endif

%ifdef  DEBUG
%include        "debug.inc"
%endif

%assign         ARGMAX      15
%assign         VSTACKMAX   1024
%assign         MEMINIT     256*1024
%assign         LSTACKMAX   127
%assign         FNAMEMAX    256
%assign         LABELMAX    1024
%assign         VERSION     30400

;==============================================================
section .text
global _start

;-------------------------------------------------------------------------
; ƥν
;-------------------------------------------------------------------------
_start:
                mov     edi, argc
                pop     ebx                     ; ebx = argc
                mov     [edi], ebx              ; argc ο¸
                mov     [edi + 4], esp          ; argvp Ƭ¸
                lea     eax, [esp+ebx*4+4]      ; Ķѿɥ쥹
                mov     [edi + 8], eax          ; envp Ķѿΰ¸

                mov     eax, [edi]              ; argc
                mov     esi, [edi + 4]          ; argvp
                mov     ecx, 1
                cmp     eax, ecx
                je      .L4                     ; ʤʤ饹å
    .L1:        mov     ebx, [esi + ecx * 4]    ; ip = argvp[r3]
                mov     dl, [ebx]
                inc     ecx
                cmp     ecx, eax
                je      .L3
                cmp     dl, '-'                 ; -פ
                jne     .L1
                dec     ecx
                mov     [edi], ecx              ; argc ο򹹿
                inc     ecx
    .L3         lea     edx, [esi + ecx*4]
                mov     [edi + 16], edx         ; vtlѤΰؤƬ
                sub     eax, ecx
                mov     [edi + 12], eax         ; vtlѤΰθĿ (argc_vtl0)

    .L4:        ; argv[0]="xxx/rvtlw" ʤ cgi⡼
                xor     edx, edx
                mov     ebx, cginame            ; ʸ 'wltvr',0
                mov     ecx, [esi]              ; argv[0]
    .L5:        mov     al, [ecx]
                inc     ecx
                cmp     al, 0
                jne     .L5
                sub     ecx, 2                  ; ʸκǽʸ(w)
    .L6:        mov     al, [ecx]
                mov     ah, [ebx]
                inc     ebx
                dec     ecx
                cmp     ah, 0
                je      .L7                     ; found
                cmp     al, ah
                jne     .L8                     ; no
                jmp     short .L6
    .L7:        inc     edx                     ; edx = 1
    .L8:        mov     [cgiflag], edx

                call    GET_TERMIOS             ; termios ¸
                call    SET_TERMIOS             ; üΥ륨OFF

                mov     ebp, VarArea            ; ̾Τν
                xor     ebx, ebx                ; 0 ϤƸͤ
                mov     eax, SYS_brk            ; ҡƬ
                int     0x80
                xor     ecx, ecx
                mov     ebx, eax                ; ҡפ˥ɤ
                mov     edx, eax
                mov     cl, ','                 ; ǽΰƬ
                mov     dword[ebp+ecx*4], eax
                mov     cl, '='                 ; ץƬ
                mov     dword[ebp+ecx*4], eax
                add     eax, 4                  ; ҡƬ
                mov     cl, '&'
                mov     dword[ebp+ecx*4], eax
                add     ebx, MEMINIT            ; ҡ(brk)
                mov     cl, '*'                 ; RAM
                mov     [ebp+ecx*4], ebx
                mov     eax, SYS_brk            ; brk
                int     0x80
                xor     eax, eax
                dec     eax
                mov     [edx] ,eax              ; ޡ

                mov     eax, 672274774          ; 
                mov     cl, '`'                 ; 
                mov     [ebp+ecx*4], eax
                call    sgenrand

                xor     ebx, ebx                ; ʥϥɥ
                mov     eax, SigIntHandler
                mov     [new_sig.sighandler], eax
                mov     [new_sig.sa_mask], ebx
                mov     eax, SA_NOCLDSTOP       ; ҥץߤ̵
                mov     [new_sig.sa_flags], eax
                mov     [new_sig.sa_restorer], ebx
                mov     eax, SYS_sigaction
                mov     ebx, SIGINT             ; ^C
                mov     ecx, new_sig
                mov     edx, old_sig
                int     0x80

                mov     eax, SIG_IGN            ; ʥ̵
                mov     [new_sig.sighandler], eax
                mov     eax, SYS_sigaction
                mov     ebx, SIGTSTP            ; ^Z
                int     0x80

                mov     eax, SYS_getpid
                int     0x80
                mov     [ebp-24], eax           ; pid ¸
                dec     eax
                ja      .not_init
                push    edi
                mov     edi, envp               ; pid=1 ʤĶѿ
                mov     dword[edi], env         ; envp Ķѿ
                pop     edi
                mov     ebx, initvtl            ; /etc/init.vtl
                call    fropen                  ; open
                jle     .not_init               ; ̵з³
                mov     [ebp-8], eax            ; FileDesc
                call    WarmInit2
                mov     byte[ebp-4], 1          ; Read from file
                mov     byte[ebp-2], 1          ; EOL=yes
                jmp     short Launch
    .not_init:
                call    WarmInit2
                xor     eax, eax
                mov     [current_arg], eax      ; ѰȽ
                call    LoadCode                ; Хץ
                jg      Launch                  ; å̵
%ifndef SMALL_VTL
                ; ưåɽ
                mov     eax, start_msg          ; ưå
                call    OutAsciiZ
%endif

Launch:         ; λ
                mov     [save_stack], esp

;-------------------------------------------------------------------------
; ᥤ롼
;-------------------------------------------------------------------------
MainLoop:
                cmp     byte[ebp-17], 1     ; SIGINT ?
                jne     .div0p
                call    WarmInit            ; ¹
                jmp     short .continue
    .div0p:     cmp     byte[ebp-18], 1     ; 0ȯ
                jne     .exp_err
                mov     eax, err_div0       ; 0å
                call    OutAsciiZ
                call    WarmInit            ; ¹
    .exp_err:   mov     bl, [ebp-19]
                cmp     bl, 0               ; ˥顼
                je      .continue
                push    eax                 ; å(ʸ)
                cmp     bl, 1
                jne     .ee1
                mov     eax, err_exp        ; å
                jmp     short .ee3
    .ee1:       cmp     bl, 2
                jne     .ee2
                mov     eax, err_vstack     ; å
                jmp     short .ee3
    .ee2:       mov     eax, err_label      ; å
    .ee3:       jmp     Error

    .continue:  cmp     byte[ebp-2], 0      ; EOL
                je      .not_eol
                cmp     byte[ebp-3], 1      ; ExecMode=Memory
                jne     ReadLine            ; Լ
                jmp     ReadMem             ; ꤫Լ

    .not_eol:   call    GetChar
    .next:      cmp     al, ' '             ; ɤФ
                jne     .done
                call    GetChar
                jmp     short .next
    .done:
                call    IsNum               ; ֹդʤԽ⡼
                jb      .exec
                call    EditMode            ; Խ⡼
                jmp     short MainLoop

    .exec:      call    IsAlpha
                jb      Command             ; ޥɼ¹
    .var        call    SetVar              ; ѿ
MainLoop2       jmp     MainLoop

;-------------------------------------------------------------------------
; ϤޤϥեϤ줿ɤ¹
;-------------------------------------------------------------------------
ReadLine:       ; 1 : ϤȥեϤб
                cmp     byte[ebp-4], 0      ; Read from ?
                je      .console            ; 󥽡뤫
                call    READ_FILE           ; ե뤫
                jmp     short .exit

    .console:   call    DispPrompt
                mov     eax, MAXLINE        ; 1 
                mov     ebx, input
                call    READ_LINE           ; Խǽե
                mov     esi, ebx
                mov     byte[ebp-2], 0      ; not EOL
    .exit:      jmp     short MainLoop2

;-------------------------------------------------------------------------
; ˳Ǽ줿ɤ¹
;-------------------------------------------------------------------------
ReadMem:
                mov     eax, [edi]          ; JUMP褫⤷ʤ
                inc     eax                 ; ԥեåȤ -1 ?
                je      .stop               ; ʤ¹Խλ
                add     edi, [edi]          ; Next Line
                mov     eax, [edi]          ; ԥեå
                or      eax, eax            ; 
                jns     .run
    .stop:
                call    CheckCGI            ; CGI⡼ɤʤ齪λ
                mov     byte[ebp-3], 0      ; ExecMode=Direct
                mov     byte[ebp-2], 1      ; EOL=yes
                jmp     short MainLoop2
    .run:
                call    SetLineNo           ; ֹ # 
                lea     esi, [edi+8]        ; ԤΥƬ
                mov     byte[ebp-2], 0      ; EOL=no
                jmp     short MainLoop2

;-------------------------------------------------------------------------
; ʸμ¹
;   ʸ¹Ԥ륵֥롼󥳡
;-------------------------------------------------------------------------
Command:
                xor     ebx, ebx
                mov     bl, al
                cmp     al, '!'
                jb      .comm2
                cmp     al, '/'
                ja      .comm2
                sub     bl,  '!'            ; ץơ֥
                call    [ebx * 4 + TblComm1]
                jmp     short MainLoop2
    .comm2:     cmp     al, ':'
                jb      .comm3
                cmp     al, '@'
                ja      .comm3
                sub     bl,  ':'
                call    [ebx * 4 + TblComm2]
                jmp     MainLoop
    .comm3:     cmp     al, '['
                jb      .comm4
                cmp     al, '`'
                ja      .comm4
                sub     bl,  '['
                call    [ebx * 4 + TblComm3]
                jmp     MainLoop
    .comm4:     cmp     al, '{'
                jb      .comexit
                cmp     al, '~'
                ja      .comexit
                sub     bl,  '{'
                call    [ebx * 4 + TblComm4]
    .exit:      jmp     MainLoop
    .comexit:   cmp     al, ' '
                je      .exit
                cmp     al, 0
                je      .exit
                cmp     al, 8
                je      .exit
                jmp     short SyntaxError

;-------------------------------------------------------------------------
; ֹ򥷥ƥѿ # 
;-------------------------------------------------------------------------
SetLineNo:
                mov     eax, [edi+4]        ; Line No.
                xor     ecx, ecx
                mov     cl, '#'
                mov     [ebp+ecx*4], eax    ; ֹ # 
                ret

;-------------------------------------------------------------------------
; ʸˡ顼
;-------------------------------------------------------------------------
LongJump:       mov     esp, [save_stack]   ; å
                push    eax                 ; ʸ
                mov     eax, err_exp        ; å
                jmp     short Error

SyntaxError:
                push    eax
                mov     eax, syntaxerr
Error:          call    OutAsciiZ
                cmp     byte[ebp-3], 0      ; ExecMode=Direct
                je      .position
                mov     eax, [edi + 4]      ; 顼Թֹ
                call    PrintLeft
                call    NewLine
                lea     eax, [edi + 8]
                call    OutAsciiZ           ; 顼ɽ
                call    NewLine
                sub     esi, edi
                mov     ecx, esi
                sub     ecx, 9
                je      .position
                cmp     ecx, MAXLINE
                jae     .skip
    .errloop:   mov     al, ' '             ; 顼
                call    OutChar
                loop    .errloop
    .position:  mov     eax, '^  ['
                call    OutChar4
                pop     eax
                call    PrintHex2           ; 顼ʸɽ
                mov     al, ']'
                call    OutChar
                call    NewLine

    .skip:      call    WarmInit            ; ƥ֤
                jmp     MainLoop

;-------------------------------------------------------------------------
; ץץɽ
;-------------------------------------------------------------------------
DispPrompt:
                mov     eax, prompt1        ; ץץɽ
                call    OutAsciiZ
                mov     eax, [ebp-24]       ; pid μ
                call    PrintHex4
                mov     eax, prompt2        ; ץץɽ
                call    OutAsciiZ
                ret

;-------------------------------------------------------------------------
; ʥϥɥ
;-------------------------------------------------------------------------
SigIntHandler:
                mov     byte[SigInt], 1     ; SIGINT ʥ
                ret

;-------------------------------------------------------------------------
; ʥˤץ߻ν
;-------------------------------------------------------------------------
RangeError:
                mov     eax, Range_msg      ; ϰϥ顼å
                call    OutAsciiZ
                xor     ecx, ecx
                mov     cl, '#'             ; ֹ
                mov     eax, [ebp+ecx*4]
                call    PrintLeft
WarmInit:
                call    CheckCGI            ; CGI⡼ɤʤ齪λ
WarmInit2:
                mov     byte[ebp-4], 0      ; Read from console
WarmInit1:
                xor     ecx, ecx
                xor     eax, eax
                inc     eax                 ; 1
                mov     cl, '['             ; ϰϥåON
                mov     [ebp+ecx*4], eax
                mov     [ebp-2], al         ; EOL=yes
                dec     eax                 ; 0
                mov     edi, exarg          ; execve 
                mov     [edi], eax
                mov     [ebp-19], al        ; Υ顼̵
                mov     [ebp-18], al        ; ̵
                mov     [ebp-17], al        ; SIGINTʥ̵
                mov     [ebp-3], al         ; ExecMode=Direct
                mov     [ebp-1], al         ; LSTACK
                mov     [ebp-16], eax       ; VSTACK
                ret

;-------------------------------------------------------------------------
; ѿؤ, FORʸ
; EAX ѿ̾ꤷƸƤӽФ
;-------------------------------------------------------------------------
SetVar:         ; ѿ
                call    SkipAlpha           ; ѿξĹʬɤФ
                push    edi
                lea     edi, [ebp+ebx*4]    ; ѿΥɥ쥹
                cmp     al, '='
                je      .var
                cmp     al, '('
                je      .array1
                cmp     al, '{'
                je      .array2
                cmp     al, '['
                je      .array4
                cmp     al, '*'
                je      .strptr
                pop     edi
                jmp     Com_Error

    .var:       ; ñѿ
                call    Exp                 ; ν(ɤ̵ǸƤ)
                mov     [edi], eax          ; 
                mov     ebx, eax
                pop     edi
                xor     eax, eax
                mov     al, [esi-1]
                cmp     al, ','             ; FORʸ?
                jne     .exit
                cmp     byte[ebp-3], 0      ; ExecMode=Direct
                jne     .for
                mov     eax, no_direct_mode
                call    OutAsciiZ
                pop     ebx                 ; å
                call    WarmInit
                jmp     MainLoop
    .for:
                mov     byte[ebp-20], 0     ; 
                call    Exp                 ; λ
                cmp     eax, ebx            ; ͤȽλͤ
                jge     .asc
                mov     byte[ebp-20], 1     ; ߽ ( >= λ)
    .asc:
                call    PushValue           ; λͤ(NEXTȽ)
                call    PushLine            ; Forʸľ
    .exit:      ret

    .array1:    call    .array
                jb      .range_err          ; ϰϳ򥢥
                mov     [edi+ebx], al       ; 
                pop     edi
                ret

    .array2:    call    .array
                jb      .range_err          ; ϰϳ򥢥
                mov     [edi+ebx*2], ax     ; 
                pop     edi
                ret

    .array4:    call    .array
                jb      .range_err          ; ϰϳ򥢥
                mov     [edi+ebx*4], eax    ; 
                pop     edi
                ret

    .range_err:
                call    RangeError          ; ǽϰϤĶ
                pop     edi
                ret

    .strptr:    call    GetChar
                mov     edi, [edi]          ; ʸ򥳥ԡ
                call    RangeCheck          ; ԡϰϥå
                jb      .range_err          ; ϰϳ򥢥
                mov     al, [esi]           ; PeekChar
                cmp     al, '"'
                jne     .sp0

                xor     ecx, ecx            ; ¨ʸ󥳥ԡ
                call    GetChar             ; skip "
    .next:      call    GetChar
                cmp     al, '"'
                je      .done
                or      al, al
                je      .done
                mov     [edi + ecx], al
                inc     ecx
                cmp     ecx, FNAMEMAX
                jb      .next
    .done:
                xor     al, al
                mov     [edi + ecx], al
                xor     ebx, ebx
                mov     bl, '%'             ; %ʸ¸
                mov     [ebp+ebx*4], ecx
                pop     edi
                ret

    .sp0:       call    Exp                 ; ԡΥɥ쥹
                cmp     edi, eax
                je      .sp3
                push    edi                 ; ԡ
                mov     edi, eax            ; RangeCheckedi򸫤
                call    RangeCheck          ; ԡϰϥå
                pop     edi                 ; ԡ
                jb      .range_err          ; ϰϳ򥢥
                push    esi
                mov     esi, eax
                xor     ecx, ecx
    .sp1:
                mov     al, [esi+ecx]
                mov     [edi+ecx], al
                inc     ecx
                cmp     ecx, 256*1024       ; 256KB
                je      .sp2
                or      al, al
                jne     .sp1
    .sp2:
                dec     ecx
                xor     ebx, ebx
                mov     bl, '%'             ; %ʸ¸
                mov     [ebp+ebx*4], ecx
                pop     esi
                pop     edi
                ret

    .sp3:       call    StrLen
                xor     ebx, ebx
                mov     bl, '%'             ; %ʸ¸
                mov     [ebp+ebx*4], eax
                pop     edi
                ret

    .array:     call    Exp                 ; 󥤥ǥå
                mov     ebx, eax
                mov     edi, [edi]
                call    SkipCharExp         ; ν(ɤ̵ǸƤ)
                call    RangeCheck          ; ϰϥå
                ret

;-------------------------------------------------------------------------
; ΥǽϰϤå
; , < edi < *
;-------------------------------------------------------------------------
RangeCheck:
                push    eax
                push    ebx
                push    ecx
                xor     ecx, ecx
                mov     cl, '['             ; ϰϥåե饰
                mov     eax, [ebp+ecx*4]
                test    eax, eax
                je      .exit               ; 0 ʤåʤ
                mov     eax, input2
                cmp     edi, eax            ; if addr=input2
                je      .exit               ; ץåȥХåեOK
                mov     cl, ','             ; ץƬ
                mov     eax, [ebp+ecx*4]
                mov     cl, '*'             ; RAM
                mov     ebx, [ebp+ecx*4]
                cmp     edi, eax            ; if = > addr, stc
                jb      .exit
                cmp     ebx, edi            ; if * < addr, stc
    .exit       pop     ecx
                pop     ebx
                pop     eax
                ret

;-------------------------------------------------------------------------
; ѿξĹʬɤФ
;   ѿ̾ebx, ʸeax֤
;   SetVar, Variable ǻ
;-------------------------------------------------------------------------
SkipAlpha:
                mov     ebx, eax            ; ѿ̾ebx
    .next:      call    GetChar
                call    IsAlpha
                jb      .exit
                jmp     short .next
    .exit:      ret

;-------------------------------------------------------------------------
; ԤԽ
;   eax ֹ
;-------------------------------------------------------------------------
LineEdit:
                call    LineSearch          ; ϺѤ߹ֹõ
                jae     .exit
                mov     esi, input          ; ϥХåե
                mov     eax, [edi + 4]
                call    PutDecimal          ; ֹ񤭹
                mov     al, ' '
                mov     [esi], al
                inc     esi
                add     edi, 8
    .copy:      mov     al, [edi]           ; ϥХåե˥ԡ
                mov     [esi], al
                cmp     al, 0
                je      .done
                inc     esi
                inc     edi
                jmp     short .copy
    .done:
                call    DispPrompt
                mov     eax, MAXLINE        ; 1 
                mov     ebx, input
                call    READ_LINE2
                mov     esi, ebx
    .exit:
                mov     byte[ebp-2], 0      ; EOL=no, ϺѤ
                ret

;-------------------------------------------------------------------------
; ListMore
;   eax ɽϹֹ
;-------------------------------------------------------------------------
ListMore:
                call    LineSearch          ; ɽϹԤ򸡺
                call    GetChar             ; skip '+'
                call    Decimal             ; ɽԿ
                jnb     .list
    .default:   xor     ebx, ebx            ; ɽԿ̵20
                mov     bl, 20
    .list:      push    edi
    .count:     mov     eax, [edi]          ; ԤޤǤΥեå
                or      eax, eax
                js      .all                ; ɺǽ?
                dec     ebx
                mov     edx, [edi + 4]      ; ֹ
                add     edi, [edi]
                or      ebx, ebx
                jne     .count
                pop     edi
                jmp     short List.loop

    .all        pop     edi                 ;
                jmp     short List.all      ; ɺǽޤ

;-------------------------------------------------------------------------
; List
;   eax ɽϹֹ, edi ɽƬɥ쥹
;-------------------------------------------------------------------------
List:
                test    eax, eax
                jne     .partial
                xor     ebx, ebx
                mov     bl, '='
                mov     edi, [ebp+ebx*4]    ; Ƭɥ쥹
                jmp     short .all
    .partial:
                call    LineSearch          ; ɽϹԤ򸡺
                call    GetChar             ; ͤǤ -
                call    Decimal             ; ϰϺǽ
                jb      .all
                mov     edx, ebx            ; λֹ
                jmp     short .loop
    .all:       xor     edx, edx
                dec     edx                 ; ǽޤɽ()
    .loop:      mov     eax, [edi]          ; ԤޤǤΥեå
                or      eax, eax
                js      .exit               ; ɺǽ?
                mov     eax, [edi + 4]      ; ֹ
                cmp     edx, eax
                jb      .exit
                call    PrintLeft           ; ֹɽ
                mov     al, ' '
                call    OutChar
                mov     ebx, 8
    .code:      mov     al, [edi + ebx]     ; ʬɽ
                cmp     al, 0
                je      .next
                call    OutChar
                inc     ebx
                jmp     short .code
    .next:      add     edi, [edi]
                call    NewLine
                jmp     short .loop         ; Խ

    .exit:      mov     byte[ebp-2], 1      ; ˹ EOL=yes
                ret

;-------------------------------------------------------------------------
;  Խ⡼
;       0) ֹ 0 ʤꥹ
;       1) ԤֹΤߤξϹԺ
;       2) ֹľ夬 - ʤֹʬꥹ
;       3) ֹľ夬 + ʤԿʬꥹ
;       4) ֹľ夬 ! ʤԽ
;       5) ƱֹιԤ¸ߤؤ
;       6) Ʊֹ椬ʤ
;-------------------------------------------------------------------------
EditMode:
                call    Decimal             ; ֹ
                xchg    eax, ebx            ; eax:ֹ, ebx:ʸ
                test    eax, eax
                je      List                ; ֹ 0 ʤꥹ
                cmp     bl, 0               ; ֹΤߤ
                je      near LineDelete     ; Ժ
                cmp     bl, '-'
                je      List                ; ʬꥹ
                cmp     bl, '+'
                je      near ListMore       ; ʬꥹ 20
%ifdef DEBUG
                cmp     bl, '#'
                je      near DebugList      ; ǥХåѹԥꥹ(#)
                cmp     bl, '$'
                je      near VarList        ; ǥХåѿꥹ($)
                cmp     bl, '%'
                je      near DumpList       ; ǥХåѥץꥹ(%)
                cmp     bl, '&'
                je      near LabelList      ; ǥХåѥ٥ꥹ(&)
%endif

    .edit:      cmp     bl, '!'
                je      near LineEdit       ; Խ
                call    LineSearch          ; ϺѤ߹ֹõ
                jae     LineInsert          ; פԤʤ
                call    LineDelete          ; ִ(Ժ+)
LineInsert:
                xor     ecx, ecx            ; ԤΥ׻
    .next:      cmp     byte[esi+ecx], 0    ; esi:Ƭ
                je      .done               ; EOLȯ (ecx ˤ n-1)
                inc     ecx                 ; ʸ
                jmp     short .next
    .done:
;                add     ecx, 9              ; ecx (+8+1)
                add     ecx, 12             ; ecx (+8+1+3)
                and     ecx, 0xfffffffc     ; 4Хȶ
                push    eax                 ; ֹ
                mov     eax, edi            ; ݥ
                push    esi                 ; ѥå׺
                push    edi                 ; 
                push    ecx                 ; 
                xor     ebx, ebx
                mov     bl, '&'             ; ҡƬƥѿ
                mov     edx, [ebp+ebx*4]
                mov     edi, edx
                add     edi, ecx            ; ҡƬ׻
                mov     [ebp+ebx*4], edi    ; ҡƬ
                mov     esi, edx            ;  &
                sub     edx, eax            ; ư=& - 
                dec     esi                 ; Ϥ old &-1 
                dec     edi                 ; new &-1 ؤΥԡ
                mov     ecx, edx
                std                         ; ư
            rep movsb
                cld
                pop     ecx                 ; 
                pop     edi                 ; ݥ
                pop     esi                 ; ϥݥ
                pop     eax                 ; ֹ

                mov     [edi], ecx          ; ԤؤΥեå
                mov     [edi+4], eax        ; ֹ
                mov     eax, 8
                add     edi, eax            ; 񤭹ֹ߰
                sub     ecx, eax            ; 񤭹ߥ
            rep movsb
                mov     byte[ebp-2], 1      ; ˹ EOL=yes
                ret

;-------------------------------------------------------------------------
; Ԥκ
;-------------------------------------------------------------------------
                align   4
LineDelete:
                push    esi
                push    edi
                call    LineSearch          ; ϺѤ߹ֹõ
                jae     .exit
                mov     esi, edi            ; Ƭ
                add     esi, [esi]          ; Ƭּ
                xor     ebx, ebx
                mov     bl, '&'             ; ҡƬ
                mov     ecx, [ebp+ebx*4]
                sub     ecx, edi            ; ecx:ưХȿ
                cld                         ; 
        rep     movsb                       ; ecxХȰư
                mov     [ebp+ebx*4], edi
    .exit:      pop     edi
                pop     esi
                mov     byte[ebp-2], 1      ; ˹  EOL=yes
                ret

;-------------------------------------------------------------------------
; ϺѤ߹ֹõ
; eax ˸ֹ
; ׹Ƭޤ԰פξˤϼ礭ֹƬ֤edi
; Ʊֹ椬Х꡼å
; ebx, edi ˲
;-------------------------------------------------------------------------
LineSearch:
                xor     ebx, ebx
                mov     bl, '='             ; ץƬ
                mov     edi, [ebp+ebx*4]

                align   4

    .nextline:  mov     ebx, [edi]          ; ʤ鸡λ
                inc     ebx
                je      .exit
                mov     ebx, [edi+4]        ; ֹ
                cmp     ebx, eax
                ja      .exit
                je      .found
                add     edi, [edi]          ; Ƭ
                jmp     short .nextline
                jne     .found
    .exit:      clc
                ret
    .found:     stc
                ret

%ifdef DEBUG

;-------------------------------------------------------------------------
; ǥХåѥץԥꥹ <xxxx> 1#
;-------------------------------------------------------------------------
DebugList:
                pusha
                xor     ebx, ebx
                mov     bl, '='             ; ץƬ
                mov     eax, [ebp+ebx*4]
                mov     ecx, eax
                mov     edi, eax
                call    PrintHex8           ; ץƬɽ
                mov     al, ' '
                call    OutChar
                mov     bl, '&'             ; ҡƬ
                mov     eax, [ebp+ebx*4]
                mov     eax, ecx
                call    PrintHex8           ; ҡƬɽ
                mov     al, ' '
                call    OutChar
                sub     eax, ecx            ; ץΰ襵
                call    PrintLeft
                call    NewLine
    .L1
                mov     eax, edi
                call    PrintHex8           ; Ƭɥ쥹
                mov     esi, [edi]          ; ԤޤǤΥեå
                mov     al, ' '
                call    OutChar
                mov     eax, esi
                call    PrintHex8           ; եåȤ16ɽ
                mov     ecx, 4              ; 4屦
                call    PrintRight          ; եåȤ10ɽ
                inc     eax
                je      .L4                 ; ɺǽ?
                mov     al, ' '
                call    OutChar

                mov     eax, [edi+4]        ; ֹ
                cmp     eax, 0
                je      .L4
                call    PrintLeft           ; ֹɽ
                mov     al, ' '
                call    OutChar
                mov     ebx, 8
    .L2
                mov     al, [edi+ebx]       ; ʬɽ
                cmp     al, 0
                je      .L3                 ; 
                call    OutChar
                inc     ebx                 ; 1ʸ
                jmp     short .L2
    .L3         call    NewLine
                add     edi, esi
                jmp     short .L1           ; Խ

    .L4         call    NewLine
                popa
                ret

;-------------------------------------------------------------------------
; ǥХåѿꥹ <xxxx> 1$
;-------------------------------------------------------------------------
VarList:
                xor     ebx, ebx
                mov     bl, 0x21
    .1          mov     al, bl
                call    OutChar
                mov     al, ' '
                call    OutChar
                mov     eax, [ebp+ebx*4]    ; ѿ
                call    PrintHex8
                mov     ecx, 12             ; ɽ
                call    PrintRight
                call    NewLine
                inc     bl
                cmp     bl, 0x7F
                jb      .1
                ret

;-------------------------------------------------------------------------
; ǥХåѥץꥹ <xxxx> 1%
;-------------------------------------------------------------------------
DumpList:
                pusha
                xor     ebx, ebx
                mov     bl, '='             ; ץƬ
                mov     edx, [ebp+ebx*4]

                and     dl, 0xf0            ; 16byteϤ
                mov     edi, edx
                mov     bl, 8
    .1
                mov     eax, edi
                call    PrintHex8           ; Ƭɥ쥹ɽ
                mov     al, ' '
                call    OutChar
                mov     al, ':'
                call    OutChar
                mov     ecx,16
    .loop
                mov     al, ' '
                call    OutChar
                mov     al, [edi]           ; 1Хɽ
                call    PrintHex2
                inc     edi
                loop    .loop
                call    NewLine
                dec     bl
                jnz     .1                  ; Խ
                popa
                ret

;-------------------------------------------------------------------------
; ǥХåѥ٥ꥹ <xxxx> 1&
;-------------------------------------------------------------------------
LabelList:
                pusha
                mov     ebx, LabelTable      ; ٥ơ֥Ƭ
                mov     ecx, TablePointer
                mov     ecx, [ecx]           ; ơ֥ǽϿ
    .1
                cmp     ebx, ecx
                jge     .2
                mov     eax, [ebx+12]
                call    PrintHex8
                mov     al, ' '
                call    OutChar
                mov     eax, ebx
                call    OutAsciiZ
                call    NewLine
                add     ebx, 16
                jmp     short .1
    .2
                popa
                ret
%endif

;-------------------------------------------------------------------------
; SkipEqualExp  = ³ɾ
; SkipCharExp   1ʸɤФ ɾ
; Exp           ɾ
; eax ֤ͤ (ɤ̵ǸƤӽФ, 1ʸɤߤ֤)
; ebx, ecx, edx, edi ¸
;-------------------------------------------------------------------------
SkipEqualExp:
                call    GetChar             ; check =
SkipEqualExp2:  cmp     al, '='             ; ɤߤλ
                je      Exp
                mov     eax, equal_err      ;
                call    OutAsciiZ
                pop     ebx                 ; å
                pop     ebx                 ; å
                jmp     SyntaxError         ; ʸˡ顼

SkipCharExp:
                call    GetChar             ; skip a character
Exp:
                mov     al, [esi]           ; PeekChar
                cmp     al, ' '
                jne     .ok
                mov     byte[ebp-19], 1     ; ζϥ顼
                jmp     LongJump            ; ȥåץ٥

    .ok:        pusha
                call    Factor
    .next:
                cmp     al,  '+'            ; ADD
                jne     .sub
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                add     ebx, ecx            ; 2û
                jmp     short .next
    .sub:       cmp     al,  '-'            ; SUB
                jne     .mul
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                sub     ebx, ecx            ; फ鱦򸺻
                jmp     short .next
    .mul:       cmp     al,  '*'            ; MUL
                jne     .div
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                push    eax
                mov     eax, ebx
                imul    ecx                 ; վ軻
                mov     ebx, eax
                pop     eax
                jmp     short .next
    .div:       cmp     al,  '/'            ; DIV
                jne     .udiv
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                or      ecx, ecx
                jne     .div1
                mov     byte[ebp-18], 1     ; 顼
                jmp     .exit
    .div1:      push    eax
                mov     eax, ebx
                cdq                         ; eax-->edx:eax
                idiv    ecx                 ; Ǻ
                xor     ecx, ecx
                mov     cl, '%'             ; ;¸
                mov     [ebp+ecx*4], edx
                mov     ebx, eax            ;  ebx 
                pop     eax
    .next2:     jmp     short .next
    .udiv:      cmp     al,  '\'            ; UDIV
                jne     .and
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                or      ecx, ecx
                jne     .udiv1
                mov     byte[ebp-18], 1     ; 顼
                jmp     .exit
    .udiv1:     push    eax
                mov     eax, ebx
                xor     edx, edx            ; eax-->edx:eax
                div     ecx                 ; Ǻ
                xor     ecx, ecx
                mov     cl, '%'             ; ;¸
                mov     [ebp+ecx*4], edx
                mov     ebx, eax            ;  ebx 
                pop     eax
                jmp     short .next2
    .and:       cmp     al,  '&'            ; AND
                jne     .or
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                and     ebx, ecx            ; ȱAND
                jmp     short .next2
    .or:        cmp     al,  '|'            ; OR
                jne     .xor
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                or      ebx, ecx            ; ȱ OR
                jmp     short .next2
    .xor:       cmp     al,  '^'            ; XOR
                jne     .equal
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                xor     ebx, ecx            ; ȱ XOR
                jmp     short .next2
    .equal:     cmp     al,  '='            ; =
                jne     .exp7
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                cmp     ebx, ecx            ; ȱ
                jne     .false
    .true:      xor     ebx, ebx
                inc     ebx                 ; 1:
                jmp     short .next2
    .false:     xor     ebx, ebx            ; 0:
    .next3:     jmp     .next
    .exp7:      cmp     al,  '<'            ; <
                jne     .exp8
                mov     al, [esi]           ; PeekChar
                cmp     al,  '='            ; <=
                je      .exp71
                cmp     al,  '>'            ; <>
                je      .exp72
                cmp     al,  '<'            ; <<
                je      .shl
                                            ; <
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                cmp     ebx, ecx            ; ȱ
                jge     .false
                jmp     short .true
    .exp71:     call    GetChar             ; <=
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                cmp     ebx, ecx            ; ȱ
                jg      .false
                jmp     short .true
    .exp72:     call    GetChar             ; <>
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                cmp     ebx, ecx            ; ȱ
                je      .false
    .true2:     jmp     short .true
    .false2     jmp     short .false
    .shl:       call    GetChar             ; <<
                push    ebx                 ; ͤ
                call    Factor              ; 
                cmp     ebx, 32             ; 32ʾϷ̤0˸
                jae     .zero
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                shl     ebx, cl             ; 򱦹 SHL (*2)
    .next4:     jmp     short .next3
    .zero:      pop     ebx
                xor     ebx, ebx
                jmp     short .next3

    .exp8:      cmp     al,  '>'            ; >
                jne     .exp9
                mov     al, [esi]           ; PeekChar
                cmp     al,  '='            ; >=
                je      .exp81
                cmp     al,  '>'            ; >>
                je      .shr
                                            ; >
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                cmp     ebx, ecx            ; ȱ
                jle     .false2
                jmp     short .true2
    .exp81:     call    GetChar             ; >=
                push    ebx                 ; ͤ
                call    Factor              ; 
                mov     ecx, ebx            ;  ecx 
                pop     ebx                 ; ι
                cmp     ebx, ecx            ; ȱ
                jl      .false2
                jmp     short .true2
    .shr:       call    GetChar             ; >>
                push    ebx                 ; ͤ
                call    Factor              ; 
                cmp     ebx, 32             ; 32ʾϷ̤0˸
                jae     .zero
                mov     ecx, ebx            ;  ecx 
    .shr2:      pop     ebx                 ; ι
                shr     ebx, cl             ; 򱦹 SHR (/2)
                jmp     short .next4
    .exp9:
    .exit:
                mov     [esp+28], ebx       ; eax ֤
                mov     [esp+ 4], esi       ; esi ֤
                popa
                ret

;-------------------------------------------------------------------------
; UNIX֤ޥñ̤֤
;-------------------------------------------------------------------------
GetTime:
                push    edi
                mov     edi, TV
                mov     eax, SYS_gettimeofday
                mov     ebx, edi
                lea     ecx, [edi + 8]      ; TZ
                int     0x80
                mov     ebx, [edi]          ; sec
                mov     eax, [edi + 4]      ; usec
                xor     ecx, ecx
                mov     cl, '%'             ; ; usec ¸
                mov     [ebp+ecx*4], eax
                pop     edi
                call    GetChar
                ret

;-------------------------------------------------------------------------
; ޥñ̤Υ꡼ _=n
;-------------------------------------------------------------------------
Com_USleep:
                call    SkipEqualExp        ; = ɤФ ɾ
                push    edi
                push    esi
                xor     ebx, ebx
                mov     edi, TV
                mov     [edi], ebx          ; sec  0
                mov     [edi+4], eax        ; usec
                mov     eax, SYS_newselect
                mov     ecx, ebx
                mov     edx, ebx
                mov     esi, ebx
                int     0x80
                call    CheckError
                pop     esi
                pop     edi
                ret

;-------------------------------------------------------------------------
; 10
; ebx ˿֤ͤ, eax,ebx,ecx 
; 1 ʸɤߤǸƤФ 1 ʸɤߤ֤
;-------------------------------------------------------------------------
Decimal:
                xor     ecx, ecx            ; 
                xor     ebx, ebx
                cmp     al, "+"
                je      .EatSign
                cmp     al, "-"
                jne     .Num
                inc     ecx                 ; 
    .EatSign:
                call    GetDigit
                jb      .exit               ; Ǥʤ֤
                jmp     short .NumLoop
    .Num:
                call    IsNum
                jb      .exit
                sub     eax, '0'
    .NumLoop:
                imul    ebx, 10             ;
                add     ebx, eax
                call    GetDigit
                jae     .NumLoop

                or      ecx, ecx            ; 餫
                je      .exit
                neg     ebx                 ; ˤ
    .exit:
                ret

;-------------------------------------------------------------------------
; ѿλ, ebx ֤ͤ
;-------------------------------------------------------------------------
Variable:
                call    SkipAlpha           ; ѿ̾ ebx
                lea     edi, [ebp+ebx*4]    ; ѿɥ쥹
                cmp     al, '('
                je      .array1
                cmp     al, '{'
                je      .array2
                cmp     al, '['
                je      .array4
                mov     ebx, [edi]          ; ñѿ
                ret

    .array1:    call    .array
                jb      .range_err          ; ϰϳ򥢥
                mov     bl, [edi + eax]
                call    GetChar             ; skip )
                ret

    .array2:    call    .array
                jb      .range_err          ; ϰϳ򥢥
                mov     bx, [edi + eax * 2]
                call    GetChar             ; skip }
                ret

    .array4:    call    .array
                jb      .range_err          ; ϰϳ򥢥
                mov     ebx, [edi + eax * 4]
                call    GetChar             ; skip ]
                ret

    .array:     call    Exp                 ; 1Х
                mov     edi, [edi]
                call    RangeCheck          ; ϰϥå
                ret

    .range_err:
                call    RangeError
                ret

;-------------------------------------------------------------------------
; ѿ
; ebx ֤ͤ (ɤ̵ǸƤӽФ, 1ʸɤߤ֤)
;-------------------------------------------------------------------------
Factor:
                call    GetChar
                call    IsNum
                jb      .bracket
                call    Decimal             ; 10
                ret

    .bracket:   cmp     al, '('
                jne     .yen
                call    Exp                 ; å
                mov     ebx, eax            ; ͤ ebx
                call    GetChar             ; skip )
                ret

    .yen:       cmp     al, '\'
                jne     .rand
                mov     al, [esi]           ; Peek Char
                cmp     al, '\'
                je      .env
                call    Exp                 ; ֹ򼨤
                mov     edx, argc_vtl
                mov     ecx, [edx]          ; vtlѤΰθĿ
                cmp     eax, ecx            ; ֹȰο
                jl      .L2                 ; ֹ < ο
                mov     ebx, [edx - 8]      ; argvp
                mov     ebx, [ebx]
    .L1:        mov     cl, [ebx]           ; 0õ
                inc     ebx
                or      cl, cl
                jne     .L1
                dec     ebx                 ; argv[0]EOL
                jmp     short .L3
    .L2:        mov     ebx, [edx + 4]      ; found [argp_vtl]
                mov     ebx, [ebx + eax*4]  ; ʸƬɥ쥹
    .L3:        ret

    .env:
                call    GetChar             ; skip '\'
                call    Exp                 ; ֹ򼨤
                mov     edx, [envp]
                xor     ecx, ecx
    .L4:        cmp     dword[edx+ecx*4], 0 ; Ķѿο򥫥
                je      .L5
                inc     ecx
                jmp     short .L4
    .L5:
                cmp     eax, ecx
                jge     short .L6           ; ֹ椬
                mov     ebx, [edx + eax*4]  ; ʸƬɥ쥹
                ret
    .L6:        lea     ebx, [edx + ecx*4]  ; null pointer ֤
                ret

    .rand:      cmp     al, '`'
                jne     .hex
                call    genrand             ; ɤ߽Ф
                mov     ebx, eax
                call    GetChar
                ret

    .hex:       cmp     al, '$'
                jne     .time
                call    Hex                 ; 16ʿޤ1ʸ
                ret

    .time:      cmp     al, '_'
                jne     .num
                call    GetTime             ; ֤֤
                ret

    .num:       cmp     al, '?'
                jne     .char
                call    NumInput            ; 
                ret

    .char:      cmp     al, 0x27
                jne     .neg
                call    CharConst           ; ʸ
                ret

    .neg:       cmp     al, '-'
                jne     .abs
                call    Factor              ; 
                neg     ebx
                ret

    .abs:       cmp     al, '+'
                jne     .realkey
                call    Factor              ; ѿ
                or      ebx, ebx
;                jns     .exit
                jns     near .exit
                neg     ebx
                ret

    .realkey:   cmp     al, '@'
                jne     .winsize
                call    RealKey             ; ꥢ륿७
                mov     ebx, eax
                call    GetChar
                ret

    .winsize:   cmp     al, '.'
                jne     .pop
                call    WinSize             ; ɥ
                mov     ebx, eax
                call    GetChar
                ret

    .pop:       cmp     al, ';'
                jne     .label
                mov     ecx, [ebp-16]       ; VSTACK
                dec     ecx
                jge     .pop2
                xor     ecx, ecx
                mov     cl, 2               ;
                mov     [ebp-19], ecx       ; ѿå顼
                jmp     short .pop3
    .pop2:
                mov     ebx, [ebp+ecx*4+1024]    ; ѿå
                mov     [ebp-16], ecx       ; åݥ󥿹
    .pop3:      call    GetChar
                ret

    .label:
%ifdef VTL_LABEL
                cmp     al, '^'
                jne     .var
                call    LabelSearch         ; ٥Υɥ쥹
                jae     .label2
                xor     ecx, ecx
                mov     cl, 3               ; ٥̤
                mov     [ebp-19], ecx       ; ٥̤顼
                call    GetChar
    .label2:
                ret
%endif

    .var:
                call    Variable            ; ѿ󻲾
    .exit       ret

;-------------------------------------------------------------------------
; 󥽡뤫
;-------------------------------------------------------------------------
NumInput:
                mov     al, [ebp-2]         ; EOL
                push    eax
                push    esi
                mov     eax, MAXLINE        ; 1 
                mov     ebx, input2         ; ԥꥢ
                call    READ_LINE3
                mov     esi, ebx
                lodsb                       ; 1ʸɤ
                call    Decimal
                pop     esi
                pop     eax
                mov     [ebp-2], al         ; EOL
                call    GetChar
                ret

;-------------------------------------------------------------------------
; 󥽡뤫 input2 ʸ
;-------------------------------------------------------------------------
StringInput:
                mov     al, [ebp-2]         ; EOL
                push    eax
                mov     eax, MAXLINE        ; 1 
                mov     ebx, input2         ; ԥꥢ
                call    READ_LINE3
                xor     edx, edx
                mov     dl, '%'             ; %ʸ¸
                mov     [ebp+edx*4], eax
                pop     eax
                mov     [ebp-2], al         ; EOL
                call    GetChar
                ret

;-------------------------------------------------------------------------
; ʸͤѴ
; ebx ˿֤ͤ, eax,ebx,ecx
;-------------------------------------------------------------------------
CharConst:
                xor     ebx, ebx
                mov     ecx, 4              ; ʸ4ХȤޤ
    .next:      call    GetChar
                cmp     al, 0x27            ; '''
                je      .exit
                shl     ebx, 8
                add     ebx, eax
                loop    .next
    .exit:      call    GetChar
                ret

;-------------------------------------------------------------------------
; 16ʸͤѴ
; ebx ˿֤ͤ, eax,ebx 
;-------------------------------------------------------------------------
Hex:
                xor     ebx, ebx
                xor     ecx, ecx
                mov     al, [esi]           ; string input
                cmp     al, '$'             ; string input
                je      StringInput         ; string input
    .next:      call    GetChar             ; $ μʸ
                call    IsNum
                jb      .hex1
                sub     al, '0'             ; Ѵ
                jmp     short .num
    .hex1:      cmp     al, ' '             ; ʳ
                je      .exit
                cmp     al, 'A'
                jb      .exit               ; 'A' 꾮ʤ
                cmp     al, 'F'
                ja      .hex2
                sub     al, 55              ; -'A'+10 = -55
                jmp     short .num
    .hex2:      cmp     al, 'a'
                jb      .exit
                cmp     al, 'f'
                ja      .exit
                sub     al, 87              ; -'a'+10 = -87
    .num:
                shl     ebx, 4
                add     ebx, eax
                inc     ecx
                jmp     short .next
    .exit:      test    ecx, ecx
                je      CharInput
                ret

;-------------------------------------------------------------------------
; ɤ1ʸɤ߹
; ESI μʸ EAX ɤ߹, ESI 򼡤ΰ֤˹
;-------------------------------------------------------------------------
GetChar:
                xor     eax, eax
                cmp     byte[ebp-2], 1      ; EOL=yes
                je      .exit
                mov     al, [esi]
                or      al, al
                jne     .getc
                mov     byte[ebp-2], 1      ; EOL=yes
    .getc:      inc     esi
    .exit:      ret

;-------------------------------------------------------------------------
; 󥽡뤫 1 ʸ, EBX֤
;-------------------------------------------------------------------------
CharInput:
                push    eax                 ; ʸ¸
                call    InChar
                mov     ebx, eax
                pop     eax
                ret

;---------------------------------------------------------------------
; AL ʸɤΥå
; ʤѴ AL ֤. ʤ饭꡼å
; ! 16ʿʸνä뤳
;---------------------------------------------------------------------

IsNum:          cmp     al, "0"             ; 0 - 9
                jb      IsAlpha2.no
                cmp     al, "9"
                ja      IsAlpha2.no
                clc
                ret
GetDigit:
                call    GetChar             ; 0 - 9
                call    IsNum
                jb      IsAlpha2.no
                sub     al, '0'             ; Ѵ
                clc
                ret

IsAlpha:        call    IsAlpha1            ; ʸ?
                jae     .yes
                call    IsAlpha2
                jb      IsAlpha2.no
    .yes:       clc
                ret

IsAlpha1:       cmp     al, "A"             ; ʸ(A-Z)?
                jb      IsAlpha2.no
                cmp     al, "Z"
                ja      IsAlpha2.no
                clc
                ret

IsAlpha2:       cmp     al, "a"             ; Ѿʸ(a-z)?
                jb      .no
                cmp     al, "z"
                ja      .no
                clc
                ret
    .no:        stc
                ret

IsAlphaNum:     call    IsAlpha             ; ʸ?
                jae     .yes
                call    IsNum
                jb      IsAlpha2.no
    .yes:       clc
                ret


;-------------------------------------------------------------------------
; ޥɥ饤ǻꤵ줿VTLɥե
;   ץ̵ͭ jg Ƚǡץʤ鿿
;-------------------------------------------------------------------------
LoadCode:
                push    ecx
                push    edi
                push    esi
                mov     edi, current_arg    ; Ѥߤΰ
                mov     ecx, [edi]
                inc     ecx                 ; ȥå
                cmp     [edi+4], ecx        ; argc θĿ
                je      .exit
                mov     [edi], ecx
                mov     esi, [edi+8]        ; argvp Ƭ
                mov     esi, [esi+ecx*4]    ; 
                mov     edi, FileName
                mov     ecx, FNAMEMAX
    .next:      mov     al, [esi]
                mov     [edi], al
                or      al, al
                je      .open
                inc     esi
                inc     edi
                loop    .next
    .open:      mov     ebx, FileName       ; ե륪ץ
                call    fropen              ; open
                jle     .exit
                mov     [ebp-8], eax        ; FileDesc
                mov     byte[ebp-4], 1      ; Read from file
                mov     byte[ebp-2], 1      ; EOL=yes
    .exit:      pop     esi
                pop     edi
                pop     ecx
                ret

;-------------------------------------------------------------------------
; եɤ߹
;-------------------------------------------------------------------------
READ_FILE:
                mov     ecx, input
                mov     ebx, [ebp-8]        ; FileDesc
    .next:
                mov     eax, SYS_read       ; ƥॳֹ
                mov     edx, 1              ; ɤߤߥХȿ
                int     0x80                ; ե뤫ɤߤ
                test    eax, eax
                je      .end                ; EOF
                cmp     byte[ecx], 10       ; LineFeed
                je      .exit
                inc     ecx
                jmp     short .next
    .end:
                mov     ebx, [ebp-8]        ; FileDesc
                call    fclose              ; File Close
                mov     byte[ebp-4], 0      ; Read from console
                call    LoadCode
                jmp     short .skip
    .exit:      mov     byte[ebp-2], 0      ; EOL=no
    .skip:      mov     [ecx], bh
                mov     esi, input
                ret

;-------------------------------------------------------------------------
; ̵10ʿʸ񤭹
;   esi μ˽񤭹
;-------------------------------------------------------------------------
PutDecimal:
                push    eax
                push    ebx
                push    ecx
                push    edx
                xor     ecx, ecx
                mov     ebx, 10
    .PL1:       xor     edx, edx            ; ̷ 0 
                div     ebx                 ; 10 ǽ
                push    edx                 ; ;(̷)PUSH
                inc     ecx                 ; 
                test    eax, eax            ; λ?
                jnz     .PL1
    .PL2:       pop     eax                 ; ̷夫 POP
                add     al,'0'              ; ʸɤѹ
                mov     [esi], al           ; Хåե˽
                inc     esi
                loop    .PL2
                pop     edx
                pop     ecx
                pop     ebx
                pop     eax
                ret

;-------------------------------------------------------------------------
; ͽ ?
;-------------------------------------------------------------------------
Com_OutNum:     call    GetChar             ; get next
                cmp     al, '='             ; PrintLeft
                jne     .ptn1
                call    Exp
                call    PrintLeft
                ret

    .ptn1:      cmp     al, '*'             ; ̵10
                je      .unsigned
                cmp     al, '$'             ; ?$ 162
                je      .hex2
                cmp     al, '#'             ; ?# 164
                je      .hex4
                cmp     al, '?'             ; ?? 168
                je      .hex8
                jmp     short .ptn2

    .unsigned:  call    SkipEqualExp     ; 1ʸɤФ ɾ
                call    PrintLeftU
                ret
    .hex2:      call    SkipEqualExp     ; 1ʸɤФ ɾ
                call    PrintHex2
                ret
    .hex4:      call    SkipEqualExp     ; 1ʸɤФ ɾ
                call    PrintHex4
                ret
    .hex8:      call    SkipEqualExp     ; 1ʸɤФ ɾ
                call    PrintHex8
                ret

    .ptn2:      mov     dl, al
                push    edx
                call    Exp
                mov     ecx, eax            ; ɽ
                and     ecx, 0xff           ; κ255
                call    SkipEqualExp     ; 1ʸɤФ ɾ
                pop     edx
                cmp     dl, '{'             ; ?{ 8ʿ
                je      .oct
                cmp     dl, '!'             ; ?! 2nӥå
                je      .bin
                cmp     dl, '('             ; ?( print right
                je      .dec_right
                cmp     dl, '['             ; ?[ print right
                je      .dec_right0
    .error:     jmp     Com_Error           ; 顼

    .oct:       call    PrintOctal
                ret
    .bin:       call    PrintBinary
                ret
    .dec_right: call    PrintRight
                ret
    .dec_right0:call    PrintRight0
                ret

;-------------------------------------------------------------------------
; ʸ $
;-------------------------------------------------------------------------
Com_OutChar:    call    GetChar             ; get next
                cmp     al, '='
                je      .char1
                cmp     al, '$'             ; $$ 2byte
                je      .char2
                cmp     al, '#'             ; $# 4byte
                je      .char3
                cmp     al, '*'             ; $*=StrPtr
                je      .char4
                ret
    .char1:     call    Exp                 ; Хʸ
                call    OutChar
                ret
    .char2:     call    SkipEqualExp        ; Хʸ
                mov     ebx, eax
                mov     al, bh
                call    OutChar
                mov     al, bl
                call    OutChar
                ret
    .char3:     call    SkipEqualExp        ; Хʸ
                mov     ebx, eax
                push    ebx
                shr     ebx, 16
                mov     al, bh
                call    OutChar
                mov     al, bl
                call    OutChar
                pop     ebx
                mov     al, bh
                call    OutChar
                mov     al, bl
                call    OutChar
                ret
    .char4:     call    SkipEqualExp
                call    OutAsciiZ
                ret

;-------------------------------------------------------------------------
;  .=n
;-------------------------------------------------------------------------
Com_Space:      call    SkipEqualExp     ; 1ʸɤФ ɾ
                mov     ecx, eax
    .loop:      mov     al, ' '
                call    OutChar
                loop    .loop
                ret

;-------------------------------------------------------------------------
; Խ /
;-------------------------------------------------------------------------
Com_NewLine:    mov     al, 10              ; LF
                call    OutChar
                ret

;-------------------------------------------------------------------------
; ʸ "
;-------------------------------------------------------------------------
Com_String:     mov     ecx, esi
                xor     edx, edx
    .next       call    GetChar
                cmp     al, '"'
                je      .exit
                cmp     byte [ebp-2], 1     ; EOL=yes ?
                je      .exit
                inc     edx
                jmp     short .next
    .exit:
                mov     eax, ecx
                call    OutString
                ret

;-------------------------------------------------------------------------
; GOTO #
;-------------------------------------------------------------------------
Com_GO:
                call    GetChar
                cmp     al, '!'
                je      .nextline           ; #! ϥ
%ifdef VTL_LABEL
                call    ClearLabel
%endif
                call    SkipEqualExp2       ; = å ɾ
    .go:
                cmp     byte[ebp-3], 0      ; ExecMode=Direct
                je      .label
%ifdef VTL_LABEL
                xor     ebx, ebx
                mov     bl, '^'             ; ƥѿ^פ
                mov     ecx, [ebp+ebx*4]    ; å
                or      ecx, ecx            ; ǥ٥뻲Ȥ뤫?
                je      .linenum            ; ̵Ϲֹ
                mov     edi, ecx            ; edi ԤƬɥ쥹
                xor     ecx, ecx            ; ƥѿ^ץꥢ
                mov     [ebp+ebx*4], ecx    ; ٥̵
                jmp     short .check
%endif

    .linenum:   or      eax, eax            ; #=0 ʤ鼡
                jne     .linenum2
    .nextline:  mov     byte[ebp-2], 1      ; EOL=yes
                ret

    .linenum2:  cmp     eax, [edi+4]        ; ߤιԤȹֹ
                jb      .top
                call    LineSearch.nextline ; ߹Ԥ鸡
                jmp     short .check
    .label:
%ifdef VTL_LABEL
                call    LabelScan           ; ٥ơ֥
%endif

    .top:       call    LineSearch          ; edi ԤƬ
    .check:     mov     eax, [edi]          ; å
                inc     eax
                je      .stop
                mov     byte[ebp-3], 1      ; ExecMode=Memory
                call    SetLineNo           ; ֹ # 
                lea     esi, [edi + 8]
                mov     byte [ebp-2], 0     ; EOL=no
                ret
    .stop:
                call    CheckCGI            ; CGI⡼ɤʤ齪λ
                call    WarmInit1           ; ϥǥХѹʤ
                ret

%ifdef VTL_LABEL
;-------------------------------------------------------------------------
; ǤΥ٥뻲ȷ̤򥯥ꥢ
;-------------------------------------------------------------------------
ClearLabel:
                xor     ecx, ecx            ; ƥѿ^ץꥢ
                xor     ebx, ebx
                mov     bl, '^'             ;
                mov     [ebp+ebx*4], ecx    ; ٥̵
                ret

;-------------------------------------------------------------------------
; ɤ򥹥󤷤ƥ٥ȥ٥μιԥɥ쥹ơ֥Ͽ
;-------------------------------------------------------------------------
LabelScan:
                pusha
                xor     ebx, ebx
                mov     bl, '='
                mov     edi, [ebp+ebx*4]    ; Ƭɥ쥹
                mov     eax, [edi]          ; ʤ齪λ
                inc     eax
                jne     .maketable
                popa
                ret

    .maketable: mov     esi, LabelTable     ; ٥ơ֥Ƭ
                mov     [TablePointer], esi ; Ͽ
                xor     ecx, ecx

    .nextline:  mov     cl, 8               ; ƥƬ
    .space:     mov     al, [edi+ecx]       ; 1ʸ
                cmp     al, 0
                je      .eol                ; 
                cmp     al, ' '             ; ɤФ
                jne     .nextch
                inc     ecx
                jmp     short .space

    .nextch:    cmp     al, '^'             ; ٥?
                jne     .eol

    .label:     inc     ecx                 ; ٥ơ֥Ͽ
                mov     esi, [TablePointer] ; Ͽ֤esi
                mov     eax, edi
                add     eax, [edi]          ; Ƭ
                mov     [esi + 12], eax     ; ɥ쥹Ͽ
                xor     edx, edx
    .label2:    mov     al, [edi+ecx]       ; 1ʸ
                cmp     al, 0
                je      .registerd          ; 
                cmp     al, ' '             ; ٥ζڤ϶
                je      .registerd          ; ٥ʸ
                cmp     edx, 11             ; 11ʸޤ
                je      .registerd          ; ʸ
                mov     [esi+edx], al
                inc     ecx
                inc     edx
                jmp     short .label2

    .registerd: mov     byte[esi+edx], 0    ; ٥ʸ
                add     esi, 16
                mov     [TablePointer], esi ; Ͽ
    .eol:       add     edi, [edi]          ; Ƭ
                mov     eax, [edi]          ; ԥեå
                inc     eax                 ; å
                je      .finish             ; λ
                cmp     esi, TablePointer   ; ơ֥ǽ
                je      .finish             ; λ
                jmp     short .nextline

    .finish:    popa
                ret

;-------------------------------------------------------------------------
; ơ֥뤫٥μιԥɥ쥹
; ٥μιԤƬɥ쥹ebxȡ^פꤷ֤
; Factoresi^μꤷƸƤФ
; esi ϥ٥θ(ĹɤФ)ꤵ
;-------------------------------------------------------------------------
LabelSearch:
                pusha
                mov     edi, LabelTable     ; ٥ơ֥Ƭ
                mov     ecx, [TablePointer] ; ơ֥ǽ

    .cmp_line:  xor     edx ,edx            ; ٥Ƭ
    .cmp_ch:    mov     al, [esi+edx]       ; ٥ʸ
                mov     bl, [edi+edx]       ; ơ֥
                or      bl, bl              ; ơ֥ʸκǸ?
                jne     .cmp_ch2            ; Ӥ³
                call    IsAlphaNum
                jb      .found              ; ȯ
    .cmp_ch2:   cmp     al, bl              ; 
                jne     .next               ; פʤϼ

                inc     edx                 ; פ鼡ʸ
                cmp     dl, 11              ; Ĺ
                jne     .cmp_ch             ; ʸ
                call    Skip_excess         ; Ĺ᤮٥϶
                                            ; ޤɤФ
    .found:     mov     eax, [edi+12]       ; ơ֥뤫饢ɥ쥹
                mov     [esp+16], eax       ; ebx ˼Ƭ֤
                xor     ebx, ebx
                mov     bl, '^'             ; ƥѿ^פ
                mov     [ebp+ebx*4], eax    ; ٥μƬ
                add     esi, edx
                call    GetChar
                mov     [esp+28], eax       ; eax 1ʸ֤
                mov     [esp+4], esi        ; esi 򹹿
                clc
                popa
                ret

    .next:      add     edi, 16
                cmp     edi, ecx            ; ٤ƤϿå
                je      .notfound
                cmp     edi, TablePointer   ; ٥ΰǽ
                je      .notfound
                jmp     short .cmp_line     ; Υơ֥륨ȥ

    .notfound:
                xor     edx, edx
                call    Skip_excess         ; ٥򤫹ޤФ
                xor     eax, eax
                mov     [esp+16], eax       ; ebx  0 ֤
                stc                         ; ʤХ꡼
                popa
                ret

Skip_excess:
    .skip:      mov     al, [esi+edx]       ; Ĺ᤮٥
                call    IsAlphaNum
                jb      .exit
                inc     edx                 ; ɤФ
                jmp     short .skip
    .exit:      ret

%endif

;-------------------------------------------------------------------------
; GOSUB !
;-------------------------------------------------------------------------
Com_GOSUB:
                cmp     byte[ebp-3], 0      ; ExecMode=Direct
                jne     .ok
                mov     eax, no_direct_mode
                call    OutAsciiZ
                pop     ebx                 ; å
                call    WarmInit
                jmp     MainLoop
    .ok:
%ifdef VTL_LABEL
                call    ClearLabel
%endif
                call    SkipEqualExp        ; = ɤФ ɾ
                call    PushLine
                call    Com_GO.go
                ret

;-------------------------------------------------------------------------
; åإɥ쥹ץå (Ԥʸ֤)
; ebx ѹ
;-------------------------------------------------------------------------
PushLine:
                xor     ebx, ebx
                mov     bl, [ebp-1]             ; LSTACK
                cmp     bl, LSTACKMAX
                jge     StackError.over         ; overflow
                mov     [ebp+ebx*4+512], edi    ; push edi
                inc     ebx
                cmp     byte [esi-1], 0
                je      .endofline              ; 
                mov     [ebp+ebx*4+512], esi    ; push esi
                jmp     short .exit
    .endofline:
                dec     esi                     ; 1ʸ᤹
                mov     [ebp+ebx*4+512], esi    ; push esi
                inc     esi                     ;
    .exit       inc     ebx
                mov     [ebp-1], bl             ; LSTACK
                ret

;-------------------------------------------------------------------------
; å饢ɥ쥹ݥå (Ԥʸ֤)
; ebx, esi, edi  ѹ
;-------------------------------------------------------------------------
PopLine:
                xor     ebx, ebx
                mov     bl, [ebp-1]             ; LSTACK
                cmp     bl, 2
                jl      StackError.under        ; underflow
                dec     ebx
                mov     esi, [ebp+ebx*4+512]    ; pop esi
                dec     ebx
                mov     edi, [ebp+ebx*4+512]    ; pop edi
                mov     [ebp-1], bl             ; LSTACK
                ret

;-------------------------------------------------------------------------
; å顼
; eax ѹ
;-------------------------------------------------------------------------
StackError:
    .over:      mov     eax, stkover
                jmp     short .print
    .under:     mov     eax, stkunder
    .print:     call    OutAsciiZ
                call    WarmInit
                ret

;-------------------------------------------------------------------------
; åؽλ(EAX)ץå
; ebx ѹ
;-------------------------------------------------------------------------
PushValue:
                xor     ebx, ebx
                mov     bl, [ebp-1]         ; LSTACK
                cmp     bl, LSTACKMAX
                jge     StackError.over
                mov     [ebp+ebx*4+512], eax
                inc     ebx
                mov     [ebp-1], bl         ; LSTACK
                ret

;-------------------------------------------------------------------------
; åνλ eax 
; eax, ebx ѹ
;-------------------------------------------------------------------------
PeekValue:
                xor     ebx, ebx
                mov     bl, [ebp-1]         ; LSTACK
                sub     bl, 3               ; ,ʸ֤
                mov     eax, [ebp+ebx*4+512]
                ret

;-------------------------------------------------------------------------
; å齪λ(EAX)ݥå
; eax, ebx ѹ
;-------------------------------------------------------------------------
PopValue:
                xor     ebx, ebx
                mov     bl, [ebp-1]         ; LSTACK
                cmp     bl, 1
                jl      StackError.under
                dec     ebx
                mov     eax, [ebp+ebx*4+512]
                mov     [ebp-1], bl         ; LSTACK
                ret

;-------------------------------------------------------------------------
; Return ]
;-------------------------------------------------------------------------
Com_Return:
                call    PopLine             ; ߹Ԥθ̵
                mov     byte[ebp-2], 0      ; not EOL
                ret

;-------------------------------------------------------------------------
; IF ;  :
;-------------------------------------------------------------------------
Com_IF:
                call    SkipEqualExp        ; = ɤФ ɾ
                or      eax, eax
                jne     Com_Comment.true
Com_Comment:    mov     byte[ebp-2], 1      ; ιԤ
    .true:
                ret

;-------------------------------------------------------------------------
; ̤ޥɽ(顼ȥå)
;-------------------------------------------------------------------------
Com_Error:
                pop     ebx                 ; å
                jmp     SyntaxError

;-------------------------------------------------------------------------
; DO UNTIL NEXT @
;-------------------------------------------------------------------------
Com_DO:
                cmp     byte[ebp-3], 0      ; ExecMode=Direct
                jne     .ok
                mov     eax, no_direct_mode
                call    OutAsciiZ
                pop     ebx                 ; å
                call    WarmInit
                jmp     MainLoop
    .ok:
                call    GetChar
                cmp     al, '='
                jne     .do
                mov     al, [esi]           ; PeekChar
                cmp     al, '('             ; UNTIL?
                jne     .next               ; ( Ǥʤ NEXT
                call    SkipCharExp         ; (ɤФƼɾ
                mov     ecx, eax            ; 
                call    GetChar             ; ) ɤ(Ȥʤ)
                call    PeekValue           ; λ
                cmp     ecx, eax            ; eax:λ
                jl      .continue
                jmp     short .exit
    .next:                                  ; FOR
                call    IsAlpha             ; al=[A-Za-z] ?
                jb      Com_Error
                push    edi
                lea     edi, [ebp+eax*4]    ; ѿΥɥ쥹
                call    Exp                 ; Ǥդμ
                mov     edx, [edi]          ; ͤ ebx 
                mov     [edi], eax          ; ѿι
                pop     edi
                mov     ecx, eax            ; 
                call    PeekValue           ; λ eax 
                cmp     byte[ebp-20], 1     ; ߽ ( > λ)
                jne     .asc

    .desc:      ; for ߽
                cmp     edx, ecx            ;  - 
                jle     Com_Error           ; Х顼
                cmp     edx, eax            ; eax:λ
                jg      .continue
                jmp     short .exit         ; λ

    .asc:       ; for 
                cmp     edx, ecx            ;  - 
                jge     Com_Error           ; 礭Х顼
                cmp     edx, eax            ; eax:λ
                jl      .continue

    .exit:      ; 롼׽λ
                xor     ebx, ebx
                mov     bl, [ebp-1]         ; LSTACK=LSTACK-3
                sub     bl, 3
                mov     [ebp-1], bl         ; LSTACK
                ret

    .continue:  ; UNTIL
                xor     ebx, ebx            ; ꥢɥ쥹
                mov     bl, [ebp-1]         ; LSTACK
                mov     esi, [ebp+ebx*4+508]    ; ebp+(ebx-1)*4+512
                mov     edi, [ebp+ebx*4+504]    ; ebp+(ebx-2)*4+512
                mov     byte[ebp-2], 0      ; not EOL
                ret

    .do:        mov     eax, 1              ; DO
                call    PushValue
                call    PushLine
                ret

;-------------------------------------------------------------------------
; = Ƭɥ쥹
;-------------------------------------------------------------------------
Com_Top:
                call    SkipEqualExp        ; = ɤФ ɾ
                push    edi
                mov     edi, eax
                call    RangeCheck          ; ',' <= '=' < '*'
                jb      Com_NEW.range_err   ; ϰϳ顼
                xor     ebx, ebx
                mov     bl, '='             ; Ƭ
                mov     [ebp+ebx*4], eax    ; ͤ=
                mov     bl, '*'             ; 
                mov     edi, [ebp+ebx*4]    ; edi=*
    .nextline:                              ; 
                mov     ebx, [eax]          ; ԤؤΥեå
                inc     ebx                 ; Ƭ -1 ?
                je      .found              ; yes
                dec     ebx                 ; ԤؤΥեåȤ᤹
                or      ebx, ebx
                jle     .endmark_err        ; ԤؤΥեå <= 0
                mov     ebx, [eax+4]        ; ֹ > 0
                or      ebx, ebx
                jle     .endmark_err        ; ֹ <= 0
                add     eax, [eax]          ; Ƭɥ쥹
                cmp     edi, eax            ; Ƭ > 
                jle     .endmark_err
                jmp     short .nextline     ; Խ
    .found:     mov     ecx, eax            ; ȯ
                pop     edi
                jmp     short Com_NEW.set_end   ; & 
    .endmark_err:
                pop     edi
                mov     eax, EndMark_msg    ; ץ̤
                call    OutAsciiZ
                call    WarmInit            ;
                ret

;-------------------------------------------------------------------------
; ޡȶƬ &
;   = (ΰƬ)ͤǻ, Хɥ쥹ꤵ
;-------------------------------------------------------------------------
Com_NEW:
                call    SkipEqualExp        ; = ɤФ ɾ
                xor     ebx, ebx
                mov     bl, '='             ; Ƭ
                mov     ecx, [ebp+ebx*4]    ; &==+4
                xor     eax, eax
                dec     eax                 ; ޡ(-1)
                mov     [ecx] ,eax          ; ޡ
    .set_end:
                mov     bl, '&'             ; Ƭ
                add     ecx, 4              ; μ
                mov     [ebp+ebx*4], ecx
                call    WarmInit1           ; ϥǥХѹʤ
                ret
    .range_err: pop     edi
                call    RangeError
                ret

;-------------------------------------------------------------------------
; BRK *
;    ǽ֤, brk
;-------------------------------------------------------------------------
Com_BRK:
                call    SkipEqualExp        ; = ɤФ ɾ
                mov     ebx, eax            ; ebx ˥ꥵ
                mov     eax, SYS_brk        ; 
                int     0x80
                xor     ebx, ebx
                mov     bl, '*'             ; ҡƬ
                mov     [ebp+ebx*4], eax
                ret

;-------------------------------------------------------------------------
; RANDOM '
;     /dev/urandom ɬץХȿɤ߽Ф
;    /usr/src/linux/drivers/char/random.c 
;-------------------------------------------------------------------------
Com_RANDOM:
                call    SkipEqualExp        ; = ɤФ ɾ
                mov     cl, '`'             ; 
                mov     [ebp+ecx*4], eax
                call    sgenrand
                ret

;-------------------------------------------------------------------------
; ʸ " ޤ EOL ޤ
;-------------------------------------------------------------------------
GetString:
                push    edi
                xor     ecx, ecx
                mov     edi, FileName
    .next:      call    GetChar
                cmp     al, '"'
                je      .exit
                or      al, al
                je      .exit
                mov     [edi + ecx], al
                inc     ecx
                cmp     ecx, FNAMEMAX
                jb      .next
    .exit:
                xor     al, al
                mov     [edi + ecx], al
                pop     edi
                ret

;-------------------------------------------------------------------------
; CodeWrite <=
;-------------------------------------------------------------------------
Com_CdWrite:
                push    edi
                push    esi
                call    GetFileName
                call    fwopen              ; open
                je      .exit
                js      .error
                mov     [ebp-12], eax       ; FileDescW
                xor     ebx, ebx
                mov     bl, '='
                mov     edi, [ebp+ebx*4]    ; Ƭɥ쥹
    .loop:      mov     esi, input2         ; ꥢ()
                mov     eax, [edi]          ; ԤؤΥեå
                inc     eax                 ; ɺǽ?
                je     .exit                ; ǽʤ齪λ
                mov     eax, [edi+4]        ; ֹ
                call    PutDecimal          ; ֹ񤭹
                mov     al, ' '             ; ڡ
                mov     [esi], al           ; Write One Char
                inc     esi
                mov     ebx, 8
    .code:      mov     al, [edi + ebx]     ; ʬɽ
                cmp     al, 0               ; ?
                je      .next               ; fileϸ弡
                mov     [esi], al           ; Write One Char
                inc     esi
                inc     ebx
                jmp     short .code
    .next:      add     edi, [edi]          ; Ƭ
                mov     byte[esi], 10       ; Խ
                inc     esi
                mov     byte[esi], 0        ; EOL
                mov     ecx, input2         ; Хåեɥ쥹
                mov     eax, ecx
                call    StrLen
                mov     edx, eax            ; 񤭤ߥХȿ
                mov     ebx, [ebp-12]       ; FileDescW
                mov     eax, SYS_write
                int     0x80
                jmp     short .loop         ; Խ
    .exit:
                mov     ebx, [ebp-12]       ; FileDescW
                call    fclose
                mov     byte[ebp-2], 1      ; EOL
                pop     esi
                pop     edi
                ret

    .error:     pop     esi
                pop     edi
                jmp     short SYS_Error

;-------------------------------------------------------------------------
; CodeRead >=
;-------------------------------------------------------------------------
Com_CdRead:
                cmp     byte[ebp-4], 1      ; Read from file
                je      .error
                call    GetFileName
                call    fropen              ; open
                je      .exit
                js      SYS_Error
                mov     [ebp-8], eax        ; FileDesc
                mov     byte[ebp-4], 1      ; Read from file
                mov     byte[ebp-2], 1      ; EOL
    .exit:      ret
    .error:
                mov     eax, error_cdread
                call    OutAsciiZ
                jmp     short SYS_Error.return

;-------------------------------------------------------------------------
; ե̾Хåե˼
;-------------------------------------------------------------------------
GetFileName:
                call    GetChar             ; skip =
                cmp     al, '='
                jne     .error
                call    GetChar             ; skip =
                cmp     al, '"'
                je      .file
                jmp     short .error
    .file:      call    GetString
                mov     eax, FileName       ; ե̾ɽ
                ; call    OutAsciiZ
                mov     ebx, eax
                ret
    .error:
                pop     ebx                 ; å

;-------------------------------------------------------------------------
; ̤ޥɽ(顼ȥå)
;-------------------------------------------------------------------------
SYS_Error:
                call    CheckError
    .return:    pop     ebx                 ; å
                call    WarmInit
                jmp     MainLoop

;-------------------------------------------------------------------------
; FileWrite (=
;-------------------------------------------------------------------------
Com_FileWrite:
                mov     al, [esi]           ; PeekChar
                cmp     al, '*'             ; (*=
                jne     .L1
                call    GetChar             ; skip (
                call    GetChar             ; skip =
                cmp     al, '='
                jne     near Com_Error
                call    Exp
                mov     ebx, eax
                jmp     short .L2
    .L1:        call    GetFileName
    .L2:        call    fwopen              ; open
                je      .exit
                js      SYS_Error
                mov     [ebp-12], eax       ; FileDescW

                xor     eax, eax
                mov     al, '{'
                mov     ecx, [ebp+eax*4]    ; Хåե
                mov     al, '}'             ; Ǽΰǽ
                mov     eax, [ebp+eax*4]    ;
                cmp     eax, ecx
                jb      .exit
                sub     eax, ecx
                mov     edx, eax            ; 񤭹ߥ
                mov     eax, SYS_write      ; ƥॳֹ
                mov     ebx, [ebp-12]       ; FileDescW
                int     0x80
                call    fclose
    .exit       ret

;-------------------------------------------------------------------------
; FileRead )=
;-------------------------------------------------------------------------
Com_FileRead:
                mov     al, [esi]           ; PeekChar
                cmp     al, '*'             ; )*=
                jne     .L1
                call    GetChar             ; skip )
                call    GetChar             ; skip =
                cmp     al, '='
                jne     near Com_Error
                call    Exp
                mov     ebx, eax
                jmp     short .L2
    .L1:        call    GetFileName
    .L2:        call    fropen              ; open
                je      .exit
                js      near SYS_Error
                mov     [ebp-12], eax       ; FileDescW

                mov     ebx, eax            ; 裱 : fd
                mov     eax, SYS_lseek      ; ƥॳֹ
                xor     ecx, ecx            ; 裲 : offset = 0
                mov     edx, SEEK_END       ; 裳 : origin
                int     0x80                ; ե륵

                push    eax                 ; file_size 
                mov     ebx, [ebp-12]       ; 裱 : fd
                mov     eax, SYS_lseek      ; ƥॳֹ
                xor     ecx, ecx            ; 裲 : offset=0
                xor     edx, edx            ; 裳 : origin=0
                int     0x80                ; եƬ˥

                xor     eax, eax
                mov     al, '{'             ; ǼΰƬ
                mov     ecx, [ebp+eax*4]    ; Хåե
                pop     edx                 ; file_size 
                mov     al, ')'             ; ɤ߹ߥ
                mov     [ebp+eax*4], edx
                mov     ebx, ecx
                add     ebx, edx
                mov     al, '}'             ; Ǽΰǽ
                mov     [ebp+eax*4], ebx    ;
                mov     al, '*'
                mov     eax, [ebp+eax*4]    ; RAM
                cmp     eax, ebx
                jl      .exit               ; ΰ­

                mov     eax, SYS_read       ; ƥॳֹ
                mov     ebx, [ebp-12]       ; FileDescW
                int     0x80                ; եΤɤߤ
                push    eax
                mov     ebx, [ebp-12]       ; FileDescW
                call    fclose
                pop     eax
                test    eax,eax             ; 顼å
    .exit       ret

;-------------------------------------------------------------------------
; եǼƬ
;-------------------------------------------------------------------------
Com_FileTop:
                call    SkipEqualExp        ; = ɤФ ɾ
                push    edi
                mov     edi, eax
                call    RangeCheck          ; ϰϥå
                pop     edi
                jb      Com_FileEnd.range_err   ; ϰϳ򥢥
                xor     ebx, ebx
                mov     bl, '{'             ; եǼƬ
                mov     [ebp+ebx*4], eax
                ret

;-------------------------------------------------------------------------
; եǼǽ
;-------------------------------------------------------------------------
Com_FileEnd:
                call    SkipEqualExp        ; = ɤФ ɾ
                push    edi
                mov     edi, eax
                call    RangeCheck          ; ϰϥå
                pop     edi
                jb      .range_err          ; ϰϳ򥢥
                xor     ebx, ebx
                mov     bl, '}'             ; եǼƬ
                mov     [ebp+ebx*4], eax
                ret
    .range_err:
                call    RangeError
                ret

;-------------------------------------------------------------------------
; CGI ⡼ɤʤ rvtl λ
;-------------------------------------------------------------------------
CheckCGI:
                cmp     dword[cgiflag], 1   ; CGI mode ?
                je      Com_Exit
                ret

;-------------------------------------------------------------------------
; λ
;-------------------------------------------------------------------------
Com_Exit:
                call    RESTORE_TERMIOS
                jmp     Exit

;-------------------------------------------------------------------------
; ϰϥåե饰 [
;-------------------------------------------------------------------------
Com_RCheck:
                call    SkipEqualExp        ; = ɤФ ɾ
                xor     ebx, ebx
                mov     bl, '['             ; ϰϥå
                mov     [ebp+ebx*4], eax
                ret

;-------------------------------------------------------------------------
; ѿޤϼ򥹥å¸
;-------------------------------------------------------------------------
Com_VarPush:
                mov     ecx, [ebp-16]       ; VSTACK
                mov     edx, VSTACKMAX - 1
    .next:
                cmp     ecx, edx
                jge     VarStackError.over
                call    GetChar
                cmp     al, '='             ; +=
                jne     .push2
                call    Exp
                mov     [ebp+ecx*4+1024], eax    ; ѿå˼¸
                inc     ecx
                jmp     short .exit
    .push2:     cmp     al, ' '
                je      .exit
                or      al, al
                ; cmp     byte [ebp-2], 1     ; EOL
                je      .exit
                mov     eax, [ebp+eax*4]    ; ѿͼ
                mov     [ebp+ecx*4+1024], eax    ; ѿå˼¸
                inc     ecx
                jmp     short .next
    .exit:
                mov     [ebp-16], ecx       ; åݥ󥿹
                ret

;-------------------------------------------------------------------------
; ѿ򥹥å
;-------------------------------------------------------------------------
Com_VarPop:
                mov     ecx, [ebp-16]       ; VSTACK
    .next:
                call    GetChar
                cmp     al, ' '
                je      .exit
                or      al, al
                ; cmp     byte [ebp-2], 1     ; EOL
                je      .exit
                dec     ecx
                jl      VarStackError.under
                mov     ebx, [ebp+ecx*4+1024]    ; ѿå
                mov     [ebp+eax*4], ebx    ; ѿͼ
                jmp     short .next
    .exit:
                mov     [ebp-16], ecx       ; åݥ󥿹
                ret

;-------------------------------------------------------------------------
; ѿåϰϥ顼
;-------------------------------------------------------------------------
VarStackError:
    .over:      mov     eax, vstkover
                jmp     short .print
    .under:     mov     eax, vstkunder
    .print:     call    OutAsciiZ
                call    WarmInit
                ret

;-------------------------------------------------------------------------
; ForkExec , ץμ¹
;-------------------------------------------------------------------------
Com_Exec:
%ifndef SMALL_VTL
                call    GetChar             ;
                cmp     al, '*'             ; ,*=A 
                jne     .normal
                call    GetChar             ; get =
                cmp     al, '='
                jne     near Com_Error
                call    Exp
                call    GetString2          ; FileName˥ԡ
                jmp     short .parse
    .normal:    cmp     byte[esi], '"'
                jne     .filename           ; , /bin/xx 
                call    GetChar             ; ,="/bin/xx yy" 
    .filename:  call    GetFileName.file    ; ץ̾
                call    NewLine

    .parse:     pusha
                call    ParseArg            ; ޥɹԤβ
                mov     edi, ebx            ; 쥯ե̾
                inc     edx                 ; ҥץο
                mov     ecx, exarg          ; char ** argp
                xor     ebp, ebp            ; Ƭץ
                cmp     edx, 1
                ja      .loop               ; ѥפɬ
                mov     eax, SYS_fork       ; ѥפξ
                int     0x80
                test    eax, eax
                je      .child              ; pid  0 ʤҥץ
                jmp     short .wait
    .loop:
                mov     esi, ipipe          ; ѥפ򥪡ץ
                mov     eax, SYS_pipe
                mov     ebx, esi            ; esi  pipe_fd Ƭ
                int     0x80                ; pipe

        ;------------------------------------------------------------
        ; fork
        ;------------------------------------------------------------
                mov     eax, SYS_fork
                int     0x80
                test    eax, eax
                je      .child              ; pid  0 ʤҥץ

        ;------------------------------------------------------------
        ; ƥץ¦ν
        ;------------------------------------------------------------
                test    ebp, ebp            ; Ƭץ?
                je      .not1st
                call    close_old_pipe
    .not1st:    push    eax                 ; ҥץ pid ¸
                mov     eax, [esi]          ; ѥ fd ΰư
                mov     [esi+8], eax
                mov     eax, [esi+4]
                mov     [esi+12], eax
                pop     eax                 ; ҥץ pid 
                dec     edx                 ; Ĥҥץο
                je      .done
    .findargp:  add     ecx, 4              ; Υޥʸõ
                cmp     dword[ecx], 0       ; ڤõ
                jne     .findargp
                add     ecx, 4              ; Υޥʸ
                inc     ebp                 ; ƬץǤϤʤ
                jmp     short   .loop
    .done:
                call    close_new_pipe
    .wait:
                mov     ebx, eax            ; Ǹ˵ưץpid
                mov     eax, SYS_wait4      ; λԤ
                mov     ecx, stat_addr
                mov     edx, WUNTRACED      ; WNOHANG
                mov     esi, ru             ; rusage
                int     0x80
                call    SET_TERMIOS         ; ҥץ
                popa
                ret

        ;------------------------------------------------------------
        ; ҥץ¦ν
        ;------------------------------------------------------------
    .child:
                call    RESTORE_TERMIOS
                push    ecx                 ; ecx  char **argp 
                dec     edx                 ; ǽץå
                jne     .pipe_out           ; ǽץǤʤ
                test    edi, edi            ; 쥯Ȥ뤫
                je      .pipe_in            ; 쥯̵, ɸ
                mov     ebx, edi            ; 쥯ե̾
                call    fwopen
                mov     ebx, eax            ; ץѤߤΥե fd
                mov     eax, SYS_dup2       ; ɸϤե
                xor     ecx, ecx
                inc     ecx                 ; ɸϤե˺ؤ
                int     0x80                ; dup2
                call    fclose              ; ebx ˤϥץ󤷤fd
                jmp     short .pipe_in

    .pipe_out:  mov     eax, SYS_dup2       ; ɸϤѥפ
                mov     ebx, [esi + 4]      ; ѥפν fd
                xor     ecx, ecx            ; new_fd
                inc     ecx                 ; ɸ
                int     0x80                ; dup2
                call    close_new_pipe
    .pipe_in:   test    ebp, ebp            ; Ƭץʤ饹å
                je      .execve
                mov     eax, SYS_dup2       ; ɸϤѥפ
                mov     ebx, [esi+8]        ; ΥѥפɽФ fd
                xor     ecx, ecx            ; new_fd ɸ
                int     0x80                ; dup2
                call    close_old_pipe
    .execve:
                pop     ecx                 ; ecx  char **argp 
                mov     eax, SYS_execve     ; ѿ
                mov     ebx, [ecx]          ; char * filename
                mov     edx, [envp]         ; char ** envp
                int     0x80
                call    CheckError          ; ʤ餳ˤʤ
                call    Exit                ; ñʤ

close_new_pipe:
                push    eax
                mov     ebx, [esi + 4]      ; ϥѥפ򥯥
                call    fclose
                mov     ebx, [esi]          ; ϥѥפ򥯥
                call    fclose
                pop     eax
                ret
close_old_pipe:
                push    eax
                mov     ebx, [esi + 12]     ; ϥѥפ򥯥
                call    fclose
                mov     ebx, [esi + 8]      ; ϥѥפ򥯥
                call    fclose
                pop     eax
                ret
%endif

;-------------------------------------------------------------------------
; Ȥ߹ߥޥɤμ¹
;-------------------------------------------------------------------------
Com_Function:
%ifndef SMALL_VTL
                call    GetChar             ; | μʸ
    .func_c     cmp     al, 'c'
                jne     .func_d
                call    def_func_c          ; |c
                ret
    .func_d:
    .func_e:    cmp     al, 'e'
                jne     .func_f
                call    def_func_e          ; |e
                ret
    .func_f:    cmp     al, 'f'
                jne     .func_l
                call    def_func_f          ; |f
                ret
    .func_l:    cmp     al, 'l'
                jne     .func_m
                call    def_func_l          ; |l
                ret
    .func_m:    cmp     al, 'm'
                jne     .func_n
                call    def_func_m          ; |m
                ret
    .func_n:
    .func_p:    cmp     al, 'p'
                jne     .func_q
                call    def_func_p          ; |p
                ret
    .func_q:
    .func_r:    cmp     al, 'r'
                jne     .func_s
                call    def_func_r          ; |r
                ret
    .func_s:    cmp     al, 's'
                jne     .func_t
                call    def_func_s          ; |s
                ret
    .func_t:
    .func_u:    cmp     al, 'u'
                jne     .func_v
                call    def_func_u          ; |u
                ret
    .func_v:    cmp     al, 'v'
                jne     .func_z
                call    def_func_v          ; |v
                ret
    .func_z:    cmp     al, 'z'
                jne     func_error
                call    def_func_z          ; |z
                ret
func_error:
                jmp     Com_Error

;------------------------------------
; |c ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_c:
                call    GetChar             ;
                cmp     al, 'a'
                je      .func_ca            ; cat
                cmp     al, 'd'
                je      .func_cd            ; cd
                cmp     al, 'm'
                je      .func_cm            ; chmod
                cmp     al, 'r'
                je      .func_cr            ; chroot
                cmp     al, 'w'
                je      near .func_cw       ; pwd
                jmp     short func_error
    .func_ca:
                mov     eax, msg_f_ca       ; |ca file
                call    FuncBegin
                mov     ebx, [ebx]          ; filename
                call    DispFile
                ret
    .func_cd:
                mov     eax, msg_f_cd       ; |cd path
                call    FuncBegin
                mov     ebx, [ebx]          ; char ** argp
                mov     eax, FileName
                call    OutAsciiZ
                call    NewLine
                mov     eax, SYS_chdir
                int     0x80
                call    CheckError
                ret
    .func_cm:
                mov     eax, msg_f_cm       ; |cm 644 file
                call    FuncBegin
                mov     eax, [ebx]          ; permission
                mov     ebx, [ebx+4]        ; file name
                call    Oct2Bin
                mov     ecx, eax
                mov     eax, SYS_chmod
                int     0x80
                call    CheckError
                ret
    .func_cr:
                mov     eax, msg_f_cr       ; |cr path
                call    FuncBegin
                mov     ebx, [ebx]          ; char ** argp
                mov     eax, FileName
                call    OutAsciiZ
                call    NewLine
                mov     eax, SYS_chroot
                int     0x80
                call    CheckError
                ret
    .func_cw:
                mov     eax, msg_f_cw      ; |cw
                call    OutAsciiZ
                mov     ebx, FileName
                mov     ecx, FNAMEMAX
                mov     eax, SYS_getcwd
                int     0x80
                call    CheckError
                mov     eax, ebx
                call    OutAsciiZ
                call    NewLine
                ret

;------------------------------------
; |e ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_e:
                call    GetChar             ;
                cmp     al, 'x'
                je      .func_ex            ; execve
                jmp     func_error
    .func_ex:   mov     eax, msg_f_ex       ; |ex file arg ..
                call    RESTORE_TERMIOS     ; ü᤹
                call    FuncBegin
                mov     eax, SYS_execve     ; ѿ
                mov     ecx, ebx            ; char ** argp
                mov     ebx, [ecx]          ; char * filename
                mov     edx, [ecx-12]       ; char ** envp
                int     0x80
                call    CheckError          ; ʤ餳ˤʤ
                call    SET_TERMIOS         ; üΥ륨OFF
                ret

;------------------------------------
; |f ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_f:
%ifdef FRAME_BUFFER
%include        "vtlfb.inc"
%endif

;------------------------------------
; |l ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_l:
                call    GetChar             ;
                cmp     al, 's'
                je      .func_ls            ; ls
                jmp     func_error

    .func_ls:   pusha
                mov     eax, msg_f_ls       ; |ls dir
                call    FuncBegin
                mov     eax, [ebx]
                mov     edx, eax
                mov     ebx, DirName
                mov     byte[ebx], 0
                test    eax, eax
                je      .empty
                call    StrLen
                mov     ecx, eax
                push    si
                push    di
                mov     esi, edx
                mov     edi, ebx
                rep     movsb
                cmp     byte[edi-1], '/'
                je      .end
                mov     byte[edi] ,'/'
                inc     edi
    .end:       mov     byte[edi], 0
                pop     di
                pop     si
                jmp     short .list
    .empty:     mov     ebx, current_dir
    .list:      call    fropen
                js      .exit0
                mov     esi, eax            ; fd
    .getdents:
                mov     ebx, esi            ; esi : fd
                mov     ecx, dir_ent
                mov     edx, size_dir_ent
                mov     eax, SYS_getdents
                int     0x80
                test    eax, eax            ; valid buffer length
                js      .exit0
                je      .exit
                mov     edi, ecx            ; edi : struct top (dir_ent)
                mov     ebp, eax            ; ebp : buffer size
    .next:
                call    GetFileStat
                mov     eax, [file_stat.st_mode]
                mov     ecx, 6
                call    PrintOctal          ; mode
                mov     eax, [file_stat.st_size+2]
                mov     ecx, 12
                call    PrintRight          ; file size
                mov     eax, ' '
                call    OutChar
                lea     eax, [edi+10]
                call    OutAsciiZ           ; filename
                call    NewLine
                movzx   eax, word[edi+8]
                sub     ebp, eax
                je      .getdents
                add     edi, eax
                jmp     short .next
    .exit0:
                call    CheckError
    .exit:      mov     ebx, esi            ; fd
                call    fclose
                popa
                ret

;------------------------------------
; |m ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_m:
                call    GetChar             ;
                cmp     al, 'd'
                je      .func_md            ; mkdir
                cmp     al, 'o'
                je      .func_mo            ; mo
                cmp     al, 'v'
                je      .func_mv            ; mv
    .func_error:jmp     func_error

    .func_md:   mov     eax, msg_f_md       ; |md dir [777]
                call    FuncBegin
                mov     eax, [ebx+4]        ; permission
                mov     ebx, [ebx]          ; directory name
                test    eax, eax
                je      .def
                call    Oct2Bin
                mov     ecx, eax
                jmp     short .not_def
    .def:       mov     ecx, 0755q
    .not_def:   mov     eax, SYS_mkdir
                int     0x80
                call    CheckError
                ret
    .func_mo:   mov     eax, msg_f_mo       ; |mo dev_name dir fstype
                call    FuncBegin
                push    edi
                push    esi
                push    ebp
                mov     ebp, ebx            ; exarg
                mov     ebx, [ebp]          ; dev_name
                mov     ecx, [ebp+4]        ; dir_name
                mov     edx, [ebp+8]        ; fstype
                mov     esi, [ebp+12]       ; flags
                or      esi, esi            ; Check ReadOnly
                je      .rw                 ; Read/Write
                mov     esi, [esi]
                mov     esi, MS_RDONLY      ; ReadOnly FileSystem
    .rw:        xor     edi, edi            ; void * data
                mov     eax, SYS_mount
                int     0x80
                call    CheckError
                pop     ebp
                pop     esi
                pop     edi
                ret
    .func_mv:   mov     eax, msg_f_mv       ; |mv fileold filenew
                call    FuncBegin
                mov     ecx, [ebx+4]
                mov     ebx, [ebx]
                mov     eax, SYS_rename
                jmp     short SysCallCheckReturn

;------------------------------------
; |p ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_p:
                call    GetChar             ;
                cmp     al, 'v'
                je      .func_pv            ; pivot_root
    .func_error:jmp     func_error

    .func_pv:   mov     eax, msg_f_pv       ; |pv /dev/hda2 /mnt
                call    FuncBegin
                mov     ecx, [ebx+4]
                mov     ebx, [ebx]
                mov     eax, SYS_pivot_root
                jmp     short SysCallCheckReturn

;------------------------------------
; |r ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_r:
                call    GetChar             ;
                cmp     al, 'd'
                je      .func_rd            ; rmdir
                cmp     al, 'm'
                je      .func_rm            ; rm
    .func_error:jmp     short def_func_p.func_error

    .func_rd:   mov     eax, msg_f_rd       ; |rd path
                call    FuncBegin           ; char ** argp
                mov     ebx, [ebx]
                mov     eax, SYS_rmdir
                jmp     short SysCallCheckReturn
    .func_rm:   mov     eax, msg_f_rm       ; |rm path
                call    FuncBegin           ; char ** argp
                mov     ebx, [ebx]
                mov     eax, SYS_unlink

SysCallCheckReturn:
                int     0x80
                call    CheckError
                ret

;------------------------------------
; |s ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_s:
                call    GetChar             ;
                cmp     al, 'f'
                je      .func_sf            ; swapoff
                cmp     al, 'o'
                je      .func_so            ; swapon
                cmp     al, 'y'
                je      .func_sy            ; sync
    .func_error:jmp     short def_func_r.func_error

    .func_sf:   mov     eax, msg_f_sf       ; |sf dev_name
                call    FuncBegin           ; const char * specialfile
                mov     ebx, [ebx]
                mov     eax, SYS_swapoff
                jmp     short SysCallCheckReturn

    .func_so:   mov     eax, msg_f_so       ; |so dev_name
                call    FuncBegin
                xor     ecx, ecx            ; int swap_flags
                mov     ebx, [ebx]          ; const char * specialfile
                mov     eax, SYS_swapon
                jmp     short SysCallCheckReturn2

    .func_sy:   mov     eax, msg_f_sy       ; |sy
                mov     eax, SYS_sync
                jmp     short SysCallCheckReturn2

;------------------------------------
; |u ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_u:
                call    GetChar             ;
                cmp     al, 'm'
                je      .func_um            ; umount
                cmp     al, 'd'
                je      func_ud             ; umount
                jmp     short def_func_s.func_error

    .func_um:   mov     eax, msg_f_um       ; |um dev_name
                call    FuncBegin           ;
                mov     ebx, [ebx]          ; dev_name
                mov     eax, SYS_umount     ; sys_oldumount
SysCallCheckReturn2:
                jmp     SysCallCheckReturn

     func_ud:
                ;------------------------------------
                ; URL ǥ
                ;  u[0] URL󥳡ʸƬ
                ;  u[1] ѹϰϤʸ
                ;  u[2] ǥɸʸƬ
                ;  u[3] ǥɸʸ֤
                ;------------------------------------
                pusha
                xor     ebx, ebx
                mov     bl, 'u'             ; 
                mov     ebp, [ebp+ebx*4]    ; ebp : argument top
                mov     eax, [ebp]          ; URL󥳡ʸƬ
                mov     ebx, [ebp +  4]     ; ѹϰϤʸ
                mov     ecx, [ebp +  8]     ; ǥɸʸƬ
                call    URL_Decode
                mov     [ebp + 12], eax     ; ǥɸʸ
                popa
                ret

;------------------------------------
; |v ǻϤޤȤ߹ߥޥ
;------------------------------------
def_func_v:
                call    GetChar             ;
                cmp     al, 'e'
                je      .func_ve            ; version
    .func_error:jmp     func_error

    .func_ve:
                xor     ebx, ebx
                mov     bl, '%'             ; 
                mov     dword[ebp+ebx*4], VERSION
                ret

;------------------------------------
; |zz ƥॳ
;------------------------------------
def_func_z:
                call    GetChar             ;
                cmp     al, 'z'
                je      .func_zz            ; system call
                jmp     short def_func_v.func_error

    .func_zz:
                call    GetChar             ; skip space
                push    edi
                push    esi
                xor     ecx, ecx
                mov     cl, 'a'
                mov     eax, [ebp+ecx*4]    ; [a] syscall no.
                inc     ecx
                mov     ebx, [ebp+ecx*4]    ; [b] param1
                inc     ecx
                inc     ecx
                mov     edx, [ebp+ecx*4]    ; [d] param3
                inc     ecx
                mov     edi, [ebp+ecx*4]    ; [e] param4
                inc     ecx
                mov     esi, [ebp+ecx*4]    ; [f] param5
                sub     cl, 3
                mov     ecx, [ebp+ecx*4]    ; [c] param2
                int     0x80
                pop     esi
                pop     edi
                call    CheckError
                ret

;---------------------------------------------------------------------
; AL ʸ16ʿɤΥå
; ʤѴ AL ֤. ʤ饭꡼å
;---------------------------------------------------------------------

IsHex:          call    IsHex1              ; ʸ?
                jae     .yes
                call    IsHex2
                jb      IsHex2.no
    .yes:       clc
                ret

IsHex1:         cmp     al, "A"             ; ʸ(A-F)?
                jb      IsHex2.no
                cmp     al, "F"
                ja      IsHex2.no
                sub     al, "A"
                add     al, 10
                clc
                ret

IsHex2:         cmp     al, "a"             ; Ѿʸ(a-f)?
                jb      .no
                cmp     al, "f"
                ja      .no
                sub     al, "a"
                add     al, 10
                clc
                ret
    .no:        stc
                ret

IsHexNum:       call    IsHex               ; 16ʸ
                jae     .yes
                call    IsNum
                jb      IsHex2.no
                sub     al, "0"
    .yes:       clc
                ret

;-------------------------------------
; URLǥ
;
; eax URL󥳡ʸƬ
; ebx ѹϰϤʸ
; ecx ˥ǥɸʸƬ
; eax ˥ǥɸʸ֤
;-------------------------------------
URL_Decode:
                pusha
                mov     esi, eax
                mov     edi, ecx
                xor     eax, eax
                xor     ecx, ecx
                push    esi
    .next:
                mov     al, [esi]           ; 󥳡ʸ
                cmp     al, '+'
                jne     .urld2
                mov     al, ' '
                mov     [edi + ecx], al     ; ǥʸ
                jmp     .urld4
    .urld2:
                cmp     al, '%'
                je      .urld3
                mov     [edi + ecx], al     ; 󥨥󥳡ʸ
                jmp     .urld4

    .urld3:
                xor     edx, edx
                inc     esi
                mov     al, [esi]
                call    IsHexNum
                jb      .urld4
                add     dl, al
                inc     esi
                mov     al, [esi]
                call    IsHexNum
                jb      .urld4
                shl     dl, 4
                add     dl, al
                mov     [edi + ecx], dl
    .urld4:
                inc     esi
                inc     ecx
                mov     edx, [esp]          ; initial esi
                sub     edx, esi
                neg     edx
                cmp     edx, ebx
                jl      .next
                pop     esi
                xor     eax, eax
                mov     [edi + ecx], al
                mov     [esp+28], ecx       ; eax ʸ֤
                popa
                ret

;-------------------------------------------------------------------------
; Ȥ߹ߴؿ
;-------------------------------------------------------------------------
FuncBegin:
                call    OutAsciiZ           ; ɬפ
                call    GetChar             ; 
                cmp     al, "*"
                jne     .line
                call    SkipEqualExp        ; eax ˥ɥ쥹
                push    edi                 ; ԡ
                mov     edi, eax            ; RangeCheckedi򸫤
                call    RangeCheck          ; ԡϰϥå
                pop     edi                 ; ԡ
                jb      .range_err          ; ϰϳ򥢥

                call    GetString2          ; FileName˥ԡ
                jmp     short .parse
    .line:      cmp     byte[esi], '"'      ; ɹԤ
                jne     .get
                call    GetChar             ; skip "
    .get:       call    GetString           ; ѥ̾μ
    .parse:     call    ParseArg            ; Υѡ
                mov     ebx, exarg
                ret

    .range_err: mov     eax, 0xFF           ; 顼ʸ FF
                jmp     LongJump            ; ǽϰϤĶ

;-------------------------------------------------------------------------
; eax Υɥ쥹FileName˥ԡ
;-------------------------------------------------------------------------
  GetString2:
                push    edi
                mov     ebx, eax
                xor     ecx, ecx
                mov     edi, FileName
    .next:      mov     al, [ebx + ecx]
                mov     [edi + ecx], al
                or      al, al
                je      .exit
                inc     ecx
                cmp     ecx, FNAMEMAX
                jb      .next
    .exit:      pop     edi
                ret

;-------------------------------------------------------------------------
; 8ʿʸͤѴ
; eax 8ʿʸͤѴ eax ֤
;-------------------------------------------------------------------------
Oct2Bin:
                push    ebx
                push    edi
                mov     edi, eax
                xor     ebx, ebx
                call    GetOctal
                ja      .exit
                mov     ebx, eax
    .OctLoop:
                call    GetOctal
                ja      .exit
                shl     ebx, 3              ;
                add     ebx, eax
                jmp     short .OctLoop
    .exit:
                mov     eax, ebx
                pop     edi
                pop     ebx
                ret

;-------------------------------------------------------------------------
; edi μ8ʿʸͤѴ eax ֤
; 8ʿʸǤʤɤ ja Ƚǽ
;-------------------------------------------------------------------------
GetOctal:
                xor     eax, eax
                mov     al, [edi]
                inc     edi
                sub     al, '0'
                cmp     al, 7
                ret

;-------------------------------------------------------------------------
; եɽ
; ebx ˥ե̾
;-------------------------------------------------------------------------
DispFile:
                pusha
                call    fropen              ; open
                call    CheckError
                je      .exit
                mov     edi, eax            ; FileDesc
                push    eax                 ; buffer on stack
    .next:
                mov     eax, SYS_read       ; ƥॳֹ
                mov     ebx, edi            ; fd
                mov     ecx, esp            ; Хåե
                xor     edx, edx
                mov     dl, 4
                int     0x80                ; ե 4 Х
                test    eax, eax
                je      .done
                js      .done
                mov     edx, eax            ; # of bytes
                mov     eax, SYS_write
                xor     ebx, ebx
                inc     ebx                 ; 1:to stdout
                mov     ecx, esp
                int     0x80
                jmp     short .next

    .done:      pop     eax
                call    fclose
    .exit:      popa
                ret

;-------------------------------------------------------------------------
; execve Ѥΰ
; ޥʸΥХåե FileName AsciiZѴƥݥ󥿤
; edx  ѥפο (ҥץ-1) ֤
; ebx ˥쥯ե̾ʸؤΥݥ󥿤֤
;-------------------------------------------------------------------------
ParseArg:
                push    edi
                push    esi
                xor     ecx, ecx            ; 󥤥ǥå
                xor     edx, edx            ; ѥפΥ
                xor     ebx, ebx            ; 쥯ȥե饰
                mov     esi, FileName       ; ޥʸΥХåե
                mov     edi, exarg          ; ݥ󥿤Ƭ
    .nextarg:
    .space:     mov     al, [esi]           ; Ϣ³Υå
                or      al, al              ; å
                je      .exit
                cmp     al, ' '
                jne     .pipe               ; ѥפΥå
                inc     esi                 ; ʤ鼡ʸ
                jmp     short .space

    .pipe:      cmp     al, '|'             ; ѥ?
                jne     .redirect
                inc     edx                 ; ѥפΥ
                xor     eax, eax
                mov     [edi + ecx*4], eax  ; ޥɤζڤ 0
                inc     ecx                 ; 󥤥ǥå
                jmp     short .check_and_next

    .redirect:  cmp     al, '>'             ; 쥯?
                jne     .arg
                inc     ebx
                xor     eax, eax
                mov     [edi + ecx*4], eax  ; ޥɤζڤ 0
                inc     ecx                 ; 󥤥ǥå
                jmp     short .check_and_next

    .arg:       mov     [edi + ecx*4], esi  ; ؤΥݥ󥿤Ͽ
                inc     ecx
    .nextchar:  mov     al, [esi]           ; ڡõ
                or      al, al              ; å
                je      .found2
                cmp     al, ' '
                je      .found
                inc     esi
                jmp     short .nextchar
    .found:     mov     byte[esi], 0        ; ڡ 0 ִ
                test    ebx, ebx            ; 쥯ȥե饰
                je      .check_and_next
    .found2:    test    ebx, ebx            ; 쥯ȥե饰
                je      .exit
                dec     ecx
                mov     ebx, [edi + ecx*4]
                inc     ecx
                jmp     short .exit

    .check_and_next:
                inc     esi
                cmp     ecx, ARGMAX
                jae     .exit
                jmp     short .nextarg

    .exit:
                xor     eax, eax
                mov     [edi + ecx*4], eax  ; ݥκǸ
                pop     esi
                pop     edi
                ret

%endif

;-------------------------------------------------------------------------
; ƥॳ륨顼å
;-------------------------------------------------------------------------
CheckError:
                push    ecx
                xor     ecx, ecx
                mov     cl, '|'             ; ֤ͤ | 
                mov     [ebp+ecx*4], eax
                pop     ecx
%ifdef  DETAILED_MSG
                call    SysCallError
%else
                test    eax, eax
                jns     .exit
                mov     eax, Error_msg
                call    OutAsciiZ
%endif
    .exit:      ret

;-------------------------------------------------------------------------
; 桼ĥޥɽ
;-------------------------------------------------------------------------
Com_Ext:
%ifndef SMALL_VTL
%include        "ext.inc"
    .func_err:  jmp     func_error
%endif
                ret

;-------------------------------------------------------------------------
; ޥѥץơ֥
;-------------------------------------------------------------------------
                align   4

TblComm1:
        dd Com_GOSUB    ;   21  !  GOSUB
        dd Com_String   ;   22  "  ʸ
        dd Com_GO       ;   23  #  GOTO ¹ιֹݻ
        dd Com_OutChar  ;   24  $  ʸɽ
        dd Com_Error    ;   25  %  ľνξ;ޤ usec ݻ
        dd Com_NEW      ;   26  &  NEW, VTLɤκǽѥɥ쥹ݻ
        dd Com_Error    ;   27  '  ʸ
        dd Com_FileWrite;   28  (  File 񤭽Ф
        dd Com_FileRead ;   29  )  File ɤ߹, ɤ߹ߥݻ
        dd Com_BRK      ;   2A  *  ǽ(brk), ݻ
        dd Com_VarPush  ;   2B  +  ѿPUSH, û黻, 
        dd Com_Exec     ;   2C  ,  fork & exec
        dd Com_VarPop   ;   2D  -  ѿPOP, 黻, νʿ
        dd Com_Space    ;   2E  .  
        dd Com_NewLine  ;   2F  /  Խ, 黻
TblComm2:
        dd Com_Comment  ;   3A  :  ޤ
        dd Com_IF       ;   3B  ;  IF
        dd Com_CdWrite  ;   3C  <  rvtlɤΥե
        dd Com_Top      ;   3D  =  Ƭɥ쥹
        dd Com_CdRead   ;   3E  >  rvtlɤΥե
        dd Com_OutNum   ;   3F  ?  ͽ  
        dd Com_DO       ;   40  @  DO UNTIL NEXT
TblComm3:
        dd Com_RCheck   ;   5B  [  Array index ϰϥå
        dd Com_Ext      ;   5C  \  ĥ  黻(unsigned)
        dd Com_Return   ;   5D  ]  RETURN
        dd Com_Comment  ;   5E  ^  ٥, ¾OR黻, ٥뻲
        dd Com_USleep   ;   5F  _  usleep, gettimeofday
        dd Com_RANDOM   ;   60  `  ݻ ()
TblComm4:
        dd Com_FileTop  ;   7B  {  եƬ(ҡΰ)
        dd Com_Function ;   7C  |  Ȥ߹ߥޥ, 顼ݻ
        dd Com_FileEnd  ;   7D  }  ե(ҡΰ)
        dd Com_Exit     ;   7E  ~  VTLλ

;==============================================================
section .data

  envstr        db   'PATH=/bin:/usr/bin', 0
  env           dd   envstr, 0
  cginame       db   'wltvr', 0

%ifndef SMALL_VTL
start_msg       db   'RVTL v.3.04 2010/02/28'
                db   ', Copyright 2002-2010 Jun Mizutani', 10,
                db   'RVTL may be copied under the terms of the GNU',
                db   ' General Public License.', 10
%ifdef DEBUG
                db   'DEBUG VERSION', 10
%endif
                db   0
%endif

initvtl         db   '/etc/init.vtl',0
prompt1         db   10,'<',0
prompt2         db   '> ',0
equal_err       db   10,'= reqiured.',0
syntaxerr       db   10,'Syntax error! at line ', 0
stkunder        db   10,'Stack Underflow!', 10, 0
stkover         db   10,'Stack Overflow!', 10, 0
vstkunder       db   10,'Variable Stack Underflow!', 10, 0
vstkover        db   10,'Variable Stack Overflow!', 10, 0
Range_msg       db   10,'Out of range!', 10, 0
EndMark_msg     db   10,'&=0 required.', 10, 0
Error_msg       db   10,'Error!', 10, 0
err_div0        db   10,'Divided by 0!',10,0
err_exp         db   10,'Error in Expression at line ',0
err_label       db   10,'Label not found!',10,0
err_vstack      db   10,'Empty stack!',10,0
error_cdread    db   10,'Code Read (>=) is not allowed!',10,0
no_direct_mode  db   10,"Direct mode is not allowed!", 10,0

                align 4
stat_addr       dd   0

;-------------------------------------------------------------------------
; Ȥ߹ߴؿѥå
;-------------------------------------------------------------------------
%ifndef SMALL_VTL
    msg_f_ca    db   0
    msg_f_cd    db   'Change Directory to ',0
    msg_f_cm    db   'Change Permission ',10, 0
    msg_f_cr    db   'Change Root to ',0
    msg_f_cw    db   'Current Working Directory : ',0
    msg_f_ex    db   'Exec Command',10, 0
    msg_f_ls    db   'List Directory ',10, 0
    msg_f_md    db   'Make Directory ',10, 0
    msg_f_mv    db   'Change Name',10, 0
    msg_f_mo    db   'Mount',10, 0
    msg_f_pv    db   'Pivot Root',10, 0
    msg_f_rd    db   'Remove Directory',10, 0
    msg_f_rm    db   'Remove File',10, 0
    msg_f_sf    db   'Swap Off',10, 0
    msg_f_so    db   'Swap On',10, 0
    msg_f_sy    db   'Sync',10, 0
    msg_f_um    db   'Unmount',10, 0
%endif
;==============================================================
section .bss

cgiflag         resd    1
current_arg     resd    1
argc            resd    1
argvp           resd    1
envp            resd    1           ; exarg - 12
argc_vtl        resd    1
argp_vtl        resd    1
exarg           resd ARGMAX+1       ; execve 
ipipe           resd    1
opipe           resd    1
ipipe2          resd    1
opipe2          resd    1
save_stack      resd    1

                alignb  4
input2          resb    MAXLINE
FileName        resb    FNAMEMAX
pid             resd    1           ; ebp-24
FOR_direct      resb    1           ; ebp-20
ExpError        resb    1           ; ebp-19
ZeroDiv         resb    1           ; ebp-18
SigInt          resb    1           ; ebp-17
VSTACK          resd    1           ; ebp-16
FileDescW       resd    1           ; ebp-12
FileDesc        resd    1           ; ebp-8
ReadFrom        resb    1           ; ebp-4
ExecMode        resb    1           ; ebp-3
EOL             resb    1           ; ebp-2
LSTACK          resb    1           ; ebp-1
VarArea         resd  256           ; ebp    Ⱦ128dwordLSTACK
VarStack        resd VSTACKMAX      ; ebp+1024
%ifdef VTL_LABEL
                alignb  4
LabelTable      resd    LABELMAX*4  ; 1024*16 bytes
TablePointer    resd    1
%endif

